library items_extended;
uses
 {$IFDEF WIN32}
  ShareMem,
 {$ENDIF}
  SysUtils,
  Classes,
  o3item,
  ac3d,
  o3utils,
  o3inventary,
  o3opengl,
  o3actors,
  StrUtils,
  o3world,
  o3game,
  odeimport,
  o3vectors,
  o3m;

{$LIBPREFIX 'lib'}

const UmbrellaTime = 15000;
type
 TDocument = class(TItem)
  text:string;
  speed:cardinal;
  procedure processParameterList(p:TParameterList); override;
  function getParameterList():TParameterList; override;
  constructor Create(s:string;own:Pointer); override;
  //procedure Render(deltaTime:integer); override;
  destructor Destroy; override;
  function getTexInfo:TItemTexInfo; override;
  procedure OnUse(actor:pointer;level:Pointer;x,y,z:integer); override;
 end;

 TUmbrella = class(TItem)
  constructor Create(s:string;own:Pointer); override;
  procedure processMessage(m:string;data:array of Pointer); override;
  procedure OnUse(actor:pointer;level:Pointer;x,y,z:integer); override;
  //procedure Render(deltaTime:integer); override;
  destructor Destroy; override;
  function getTexInfo:TItemTexInfo; override;
 end;
 TLife = class(TItem)
  constructor Create(s:string;own:Pointer); override;
  //procedure Render(deltaTime:integer); override;
  destructor Destroy; override;
  function getTexInfo:TItemTexInfo; override;
 end;
 THammer = class(TItem)
  constructor Create(s:string;own:Pointer); override;
  //procedure Render(deltaTime:integer); override;
  destructor Destroy; override;
  function getTexInfo:TItemTexInfo; override;
 end;
 TSpring = class(TItem)
  constructor Create(s:string;own:Pointer); override;
  //procedure Render(deltaTime:integer); override;
  destructor Destroy; override;
  function getTexInfo:TItemTexInfo; override;
  procedure OnUse(actor:pointer;level:Pointer;x,y,z:integer); override;
 end;
 TShogunDotSize = (dot_s,dot_m,dot_l);
 TShogunDot = class(TItem)
  size:TShogunDotSize;
  frame:single;
  last:boolean;
  constructor Create(s:string;own:Pointer); override;
  procedure Render(deltaTime:integer); override;
  procedure OnActorOver(actor:pointer;level:Pointer;x,y,z:integer); override;
 end;

 var image_umbrella,image_life,image_document,image_spring,image_hammer:TO3mFile;
     ozone:TOzoneMainClass;
     p:string;
     images_shogundot:array[TShogunDotSize] of TO3mFile;
     texinfo_hammer,texinfo_umbrella,texinfo_life,texinfo_document,texinfo_spring:TItemTexInfo;

constructor TShogunDot.Create;
var t:string;
begin
 inherited Create(s,own);
 size:=dot_s;
 frame:=0;
 t:=getToken(s,2,':');
 if t='m' then size:=dot_m;
 if t='l' then size:=dot_l;
 gfx:=images_shogundot[size];
 gfxtype:=o3utils.ozone;
 TO3mFile(gfx).FDispListID:=NO_DISPLAYLIST;
 TO3mFile(gfx).FPalette[0].Transparency:=0.5;
 TO3mFile(gfx).isTransparent:=true;
 last:=false;
end;

procedure TShogunDot.Render;
var  cell:TCell;
     nl:boolean;
begin
 cell:=TLevel(owner).getCell(x,y,z);
 TO3mFile(gfx).Fobject.kids[0].trans[1]:=0;
 TO3mFile(gfx).FPalette[0].Emissive.r:=abs(frame-5)/40;
 TO3mFile(gfx).FPalette[0].Emissive.g:=abs(frame-5)/40;
 TO3mFile(gfx).FPalette[0].Emissive.b:=0.5+abs(frame-5)/40;
 nl:=false;
 if (cell<>nil)and(cell.FStone<>nil)and(cell.FStone.info['shogun']='yes') then begin
  if size=dot_s then begin
   TO3mFile(gfx).Fobject.kids[0].trans[1]:=0.785;
   if cell.FStone.info['stack']='s' then begin
    TO3mFile(gfx).FPalette[0].Emissive.r:=0.5+abs(frame-5)/40;
    TO3mFile(gfx).FPalette[0].Emissive.g:=abs(frame-5)/40;
    TO3mFile(gfx).FPalette[0].Emissive.b:=0;//abs(frame-5)/40;
    nl:=true;
   end;
  end;
  if size=dot_m then begin
   TO3mFile(gfx).Fobject.kids[0].trans[1]:=0.885;
   if cell.FStone.info['stack']='sm' then begin
    TO3mFile(gfx).FPalette[0].Emissive.r:=0.5+abs(frame-5)/40;
    TO3mFile(gfx).FPalette[0].Emissive.g:=abs(frame-5)/40;
    TO3mFile(gfx).FPalette[0].Emissive.b:=0;//abs(frame-5)/40;
    nl:=true;
   end;
  end;
  if size=dot_l then begin
   TO3mFile(gfx).Fobject.kids[0].trans[1]:=0.985;
   if cell.FStone.info['stack']='sml' then begin
    TO3mFile(gfx).FPalette[0].Emissive.r:=0.5+abs(frame-5)/40;
    TO3mFile(gfx).FPalette[0].Emissive.g:=abs(frame-5)/40;
    TO3mFile(gfx).FPalette[0].Emissive.b:=0;//abs(frame-5)/40;
    nl:=true;
   end;
  end;
 end;
 if last<>nl then begin
  if nl then TLevel(owner).sendSignal(self,1)
        else TLevel(owner).sendSignal(self,0);
 end;
 last:=nl;
 frame:=frame+deltaTime/200;
 if frame>10 then
  frame:=frame-10;
// if ozone<>nil then
 inherited Render(deltaTime);
end;

procedure TShogunDot.OnActorOver;
begin
end;

constructor TSpring.Create;
begin
 inherited Create(s,own);
 gfx:=image_spring;
 gfxtype:=o3utils.ozone;
 shadow:=ozone.shadowLib['sh-spring'];
end;

//procedure TSpring.Render;
//begin
// if ozone<>nil then
//  ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
//end;

procedure TSpring.OnUse;
var p:PdVector3;
const JUMPING_SPEED = 6;
begin
 if not TActor(actor).physics.jumping then
  if TActor(actor).body<>nil then begin
   p:=dBodyGetLinearVel(TActor(actor).body);
   dBodySetLinearVel(TActor(actor).body,p[0],JUMPING_SPEED,p[2]);
   ozone.soundLib.playSound('spring_jump',TActor(actor).cx,TActor(actor).cy,TActor(actor).cz);
  end;
end;

destructor TSpring.Destroy;
begin
 inherited Destroy;
end;

function TSpring.getTexInfo;
begin
 Result:=texinfo_spring;
end;

{procedure TLife.Render;
begin
 if Ozone<>nil then
  Ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
end;}

function TLife.getTexInfo;
begin
 Result:=texinfo_life;
end;

constructor TLife.Create;
begin
 inherited Create(s,own);
 gfx:=image_life;
 gfxtype:=o3utils.ozone;
 info['extralife']:='yes';
 shadow:=ozone.shadowLib['sh-extralife'];
end;

destructor TLife.Destroy;
begin
 inherited Destroy;
end;

{procedure THammer.Render;
begin
 if Ozone<>nil then
  Ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
end;
 }
function THammer.getTexInfo;
begin
 Result:=texinfo_hammer;
end;

constructor THammer.Create;
begin
 inherited Create(s,own);
 gfx:=image_hammer;
 gfxtype:=o3utils.ozone;
 info['hammer']:='yes';
 shadow:=ozone.shadowLib['sh-hammer'];
end;

destructor THammer.Destroy;
begin
 inherited Destroy;
end;

function MakeItem(s:string;owner:Pointer):TItem;
begin
 Result:=nil;
 if Pos('it-extralife',s)<>0 then
  Result:=TLife.Create(s,owner);
 if Pos('it-document',s)<>0 then
  Result:=TDocument.Create(s,owner);
 if Pos('it-umbrella',s)<>0 then
  Result:=TUmbrella.Create(s,owner);
 if Pos('it-spring',s)<>0 then
  Result:=TSpring.Create(s,owner);
 if Pos('it-hammer',s)<>0 then
  Result:=THammer.Create(s,owner);
 if Pos('it-shogun',s)<>0 then
  Result:=TShogunDot.Create(s,owner);
end;

procedure InitLib(path:string;owner:Pointer);
begin
 Ozone:=owner;
 p:=path;
 image_life:=TO3mFile.Create(ozone);
 image_life.LoadFromFile(p+'it-extralife.o3m');
 image_document:=TO3mFile.Create(ozone);
 image_document.LoadFromFile(p+'it-document.o3m');
 image_umbrella:=TO3mFile.Create(ozone);
 image_umbrella.LoadFromFile(p+'it-umbrella.o3m');
 image_spring:=TO3mFile.Create(ozone);
 image_spring.LoadFromFile(p+'it-spring.o3m');
 image_hammer:=TO3mFile.Create(ozone);
 image_hammer.LoadFromFile(p+'it-hammer.o3m');
 images_shogundot[dot_s]:=TO3mFile.Create(ozone);
 images_shogundot[dot_s].LoadFromFile(p+'it-shogun-s.o3m');
 images_shogundot[dot_m]:=TO3mFile.Create(ozone);
 images_shogundot[dot_m].LoadFromFile(p+'it-shogun-m.o3m');
 images_shogundot[dot_l]:=TO3mFile.Create(ozone);
 images_shogundot[dot_l].LoadFromFile(p+'it-shogun-l.o3m');
 ozone.O3Log.LogStatus('makeing item gfx','libitems_extended');
 ozone.invSys.CreateItemGfx('it-extralife.png',texinfo_life);
 ozone.invSys.CreateItemGfx('it-document.png',texinfo_document);
 ozone.invSys.CreateItemGfx('it-umbrella.png',texinfo_umbrella);
 ozone.invSys.CreateItemGfx('it-spring.png',texinfo_spring);
 ozone.invSys.CreateItemGfx('it-hammer.png',texinfo_hammer);
 ozone.O3Log.LogStatus('init ok','libitems_extended');
end;

procedure QuitLib;
begin
 if image_life<>nil then
  image_life.Free;
 if image_document<>nil then
  image_document.Free;
 if image_umbrella<>nil then
  image_umbrella.Free;
 if image_spring<>nil then
  image_spring.Free;
 if image_hammer<>nil then
  image_hammer.Free;
 if images_shogundot[dot_s]<>nil then
  images_shogundot[dot_s].Free;
 if images_shogundot[dot_m]<>nil then
  images_shogundot[dot_m].Free;
 if images_shogundot[dot_l]<>nil then
  images_shogundot[dot_l].Free;
 if ozone<>nil then begin
  ozone.invSys.FreeItemGfx(texinfo_life);
  ozone.invSys.FreeItemGfx(texinfo_document);
  ozone.invSys.FreeItemGfx(texinfo_umbrella);
  ozone.invSys.FreeItemGfx(texinfo_spring);
  ozone.invSys.FreeItemGfx(texinfo_hammer);
 end;
end;

procedure TDocument.processParameterList(p:TParameterList);
begin
 info['cmd']:=GetToken(info['cmd'],1,':')+':'+AnsiReplaceText(p[0].stringValue,' ','_')+'$'+IntToStr(p[1].uintValue);
end;

function TDocument.getParameterList:TParameterList;
var t:TObjParameter;
begin
 Result:=TParameterList.Create;
 t:=TObjParameter.Create;
 t.StringValue:=text;
 t.desc:='Text';
 Result.Add(t);
 t:=TObjParameter.Create;
 t.UIntValue:=speed;
 t.desc:='Scroll Speed';
 Result.Add(t);
end;


procedure TDocument.OnUse;
begin
 TActor(Actor).Inventary.StartScrollText(text,speed);
 TActor(Actor).Inventary.Remove(self);
 Self.Free;
end;

{procedure TDocument.Render;
begin
 if ozone<>nil then
  ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
end;
 }
function TDocument.getTexInfo;
begin
 Result:=texinfo_document;
end;

constructor TDocument.Create;
var t,n,v:string;
begin
 text:='';
 speed:=2;
 n:=GetToken(s,1,':');
 t:=GetToken(s,2,':');
 v:=GetToken(t,2,'$');
 t:=GetToken(t,1,'$');
 t:=AnsiReplaceText(t,'_',' ');
 inherited Create(s,own);
 gfx:=image_document;
 gfxtype:=o3utils.ozone;
 text:=t;
 speed:=StrToInt(v);
 shadow:=ozone.shadowLib['sh-document'];
end;

destructor TDocument.Destroy;
begin
 inherited Destroy;
end;


{procedure TUmbrella.Render;
begin
 if ozone<>nil then
  ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
end;
 }
function TUmbrella.getTexInfo;
begin
 Result:=texinfo_umbrella;
end;

constructor TUmbrella.Create;
begin
 inherited Create(s,own);
 gfx:=image_umbrella;
 gfxtype:=o3utils.ozone;
 shadow:=ozone.shadowLib['sh-umbrella'];
end;

procedure TUmbrella.processMessage;
begin
 inherited;
end;

procedure TUmbrella.OnUse;
begin
 TActor(Actor).makeGodFor(UmbrellaTime);
 TActor(Actor).Inventary.Remove(self);
 Self.Free;
end;

destructor TUmbrella.Destroy;
begin
 inherited Destroy;
end;


exports
 MakeItem,
 InitLib,
 QuitLib;
begin
end.
