library stone_oxyd;

uses
  {$IFDEF WIN32}ShareMem,{$ENDIF}
  SysUtils,
  Classes,
  ac3d,
  o3utils,
  o3stones,
  o3world,
  o3game,
  o3m;

{$LIBPREFIX 'lib'}

type TOxyd = class(TStone)
               color:integer;
               Fopen:boolean;
               oframe:integer;
               cframe:integer;
               frameDur:integer;
               procedure setOpen(const val:boolean);
               procedure Render(timeDelta:integer); override;
               property open:boolean read FOpen write SetOpen;
               constructor create(s:string;own:pointer); reintroduce;
               procedure processMessage(m:string;data:array of pointer); override;
              end;

const ColorCount = 4;

var OpenOxyd:TOxyd;
    base:TO3mFile;
    close:TO3mFile;
    colors:array[1..ColorCount] of TO3mFile;
    ozone:TOzoneMainClass;

 function CollFuncOxyd(dir:integer;call:TStone;x,y,z:integer;actor:Pointer;level:Pointer;geom:pointer):boolean;
 begin
  Result:=true;
  if call.Info['oxyd'] = 'yes' then begin
   if (TOxyd(Call).open) then Exit;
   if (OpenOxyd = nil) then begin
    OpenOxyd:=TOxyd(call);
    OpenOxyd.open:=true;
    if not TLevel(level).UpdateAllOxydsOpen then
     ozone.soundLib.playSound('oxyd_open',call.cx,call.cy,call.cz);
   end
   else begin
    if OpenOxyd.color=TOxyd(call).color then begin
     TOxyd(call).open:=true;
     OpenOxyd:=nil;
     if not TLevel(level).UpdateAllOxydsOpen then
      ozone.soundLib.playSound('oxyd_pair',call.cx,call.cy,call.cz);
    end
    else begin
     OpenOxyd.open:=false;
     OpenOxyd:=TOxyd(call);
     OpenOxyd.open:=true;
     ozone.soundLib.playSound('oxyd_nopair',call.cx,call.cy,call.cz);
    end;
   end;
  end;
 end;

 procedure TOxyd.processMessage;
 begin
  if (m='signal')or(m='boldercollision')or(m='laserhit') then
   CollFuncOxyd(1,self,fx,fy,fz,nil,owner,nil);
 end;

 constructor TOxyd.create;
 begin
  inherited Create(s,'block',own);
  mu:=0;
  //info := TInfoList.Create;
  gfx:=base;
  gfxType:=o3utils.ozone;
  shadow:=ozone.ShadowLib['sh-stone'];
 end;

 function CreateOxyd(s:string;o:Pointer):TOxyd;
 begin
  Result:=TOxyd.Create(s,o);
  s:=Copy(s,8,255);
  Result.collisionCallback:=CollFuncOxyd;
  Result.fric:=0.01;
  Result.steer:=0;
  Result.color:=StrToInt(s);
  Result.Fopen:=false;
  Result.Info['oxyd']:='yes';
  Result.oframe:=0;
  Result.cframe:=0;
  Result.frameDur:=0;
  Result.x:=-1;
  Result.y:=-1;
  Result.z:=-1;
  OpenOxyd:=nil;
 end;

 procedure TOxyd.setOpen;
 begin
  frameDur:=0;
  if open then
   oframe:=-90
  else
   oframe:=1;
  Fopen:=val;
  if val then Info['open']:='yes'
  else Info['open']:='no';
 end;

 procedure TOxyd.Render;
 begin
//  ozone.gfxSys.DrawModel(base,0,0,0,o3utils.ozone);
  inherited Render(timeDelta);
  if TLevel(owner).editorMode then begin
    ozone.gfxSys.DrawModel(colors[color],0,0.11,0,o3utils.ozone,gfxInfo);
  end
  else begin
   if open then begin
    if OpenOxyd<>Self then begin
     ozone.gfxSys.DrawModel(colors[color],0,-abs(cframe)/100,0,o3utils.ozone,gfxInfo);
    end
    else begin
     ozone.gfxSys.DrawModel(colors[color],0,abs(cframe)/50+0.11,0,o3utils.ozone,gfxInfo);
    end;
    inc(frameDur,timeDelta);
    while frameDur>50 do begin
     dec(frameDur,50);
     inc(cFrame);
     if cFrame>=10 then
      dec(cFrame,20);
    end;
   end;
   if (not open) or (oframe<>0) then begin
    if oframe<>0 then begin
     close.Fobject.kids[0].rotate[0]:=30;
     close.Fobject.kids[3].rotate[0]:=-30;
     close.Fobject.kids[1].rotate[2]:=30;
     close.Fobject.kids[2].rotate[2]:=-30;
     if ((oframe<30)and(oframe>-30)) then begin
      close.Fobject.kids[0].rotate[0]:=abs(oframe);
      close.Fobject.kids[3].rotate[0]:=-abs(oframe);
      close.Fobject.kids[1].rotate[2]:=abs(oframe);
      close.Fobject.kids[2].rotate[2]:=-abs(oframe);
     end;
     if abs(oframe)>30 then
      ozone.gfxSys.DrawModel(close,0,-(abs(oframe)-30)/60,0,o3utils.ozone,gfxInfo)
     else
      ozone.gfxSys.DrawModel(close,0,0,0,o3utils.ozone,gfxInfo);
    end
    else
      ozone.gfxSys.DrawModel(close,0,0,0,o3utils.ozone,gfxInfo);
    if oframe<>0 then begin
     close.FObject.Kids[0].Rotate[0]:=0;
     close.FObject.Kids[3].Rotate[0]:=0;
     close.FObject.Kids[1].Rotate[2]:=0;
     close.FObject.Kids[2].Rotate[2]:=0;
     close.FObject.Kids[0].Trans[1]:=0;
     close.FObject.Kids[1].Trans[1]:=0;
     close.FObject.Kids[2].Trans[1]:=0;
     close.FObject.Kids[3].Trans[1]:=0;
     inc(frameDur,timeDelta);
     while (frameDur>15)and(oframe<>0) do begin
      dec(frameDur,15);
      inc(oFrame);
      if oFrame>=90 then begin
       oFrame:=0;
      end;
     end;
    end;

   end;
  end;
 end;


  function MakeStone(s:string;o:Pointer):TOxyd;
  begin
   Result:=nil;
   if Copy(s,1,7)='st-oxyd' then
    Result:=CreateOxyd(s,o);
  end;

  procedure InitLib(path:string;owner:Pointer);
  var x:integer;
  begin
   ozone:=owner;
   base:=TO3mFile.Create(owner);
   base.LoadFromFile(path+'oxydbase.o3m');
   close:=TO3mFile.Create(owner);
   close.LoadFromFile(path+'oxyd-close-new.o3m');
   for x:=1 to ColorCount do begin
    colors[x]:=TO3mFile.Create(owner);
    colors[x].LoadFromFile(path+'oxyd'+inttostr(x)+'.o3m');
   end;
  end;

  procedure QuitLib;
  var x:integer;
  begin
   if base<>nil then base.Free;
   if close<>nil then close.Free;
   for x:=1 to ColorCount do begin
    if colors[x]<>nil then colors[x].Free;
   end;
  end;


  exports InitLib,
          QuitLib,
          MakeStone;
begin
end.
