library stones_extended;

uses
  {$IFDEF WIN32}
   ShareMem,
  {$ENDIF}
  SysUtils,
  Classes,
  ac3d,
  md2,
  o3m,
  o3utils,
  o3stones,
  o3item,
  o3world,
  o3game,
  o3actors,
  StrUtils,
  o3basicstones,
  Math,
  odeimport;

 {$LIBPREFIX 'lib'}


type TDeath = class(TStone)

              // procedure Render(timeDelta:integer); override;
               constructor create(s:string;own:pointer); reintroduce;
              end;
      TActorColorType = (acColWhite,acColBlack,acColGreen);
      TActorColorStone = class(TStone)
               color:TActorColorType;
              // procedure Render(timeDelta:integer); override;
               constructor create(s:string;own:pointer); reintroduce;
              end;
     TBolderDir = (BN,BE,BS,BW);
     TBolder = class(TStone)
                direction:TBolderDir;
                speed:single; // second per sqare
                time:integer;
                outoflev:boolean;
                laserchange:boolean;
                procedure processParameterList(p:TParameterList); override;
                function getParameterList:TParameterList; override;
                procedure Render(timeDelta:integer); override;
                procedure CallBack(timeDelta:integer); override;
                constructor create(s:string; own:pointer); reintroduce;
                destructor destroy; override;
                procedure processMessage(m:string;data:array of pointer); override;
                function NextX:integer;
                function NextZ:integer;
//                procedure CallBack(t:integer);
               end;
     TSwitch = class(TStone)
                state:boolean;
                procedure toggle;
                //procedure Render(timeDelta:integer); override;
                constructor create(s:string; own:pointer); reintroduce;
               end;
     TDoor = class(TStone)
              state:boolean;
              anim:single;
              dtype:(v,h);
              procedure Render(timeDelta:integer); override;
              procedure toggle;
              procedure processMessage(m:string;data:array of pointer); override;
              constructor create(s:string; own:pointer); reintroduce;
             end;
     TBlock_Break = class(TStone)
              anim:single;
              isBreaking:boolean;
              isCracked:boolean;
              procedure processParameterList(p:TParameterList); override;
              function getParameterList:TParameterList; override;
              procedure Render(timeDelta:integer); override;
              procedure processMessage(m:string;data:array of pointer); override;
              constructor create(s:string; own:pointer); reintroduce;
             end;
     TCharge = -1..1;
     TCharger = class(TStone)
                 charge:TCharge;
                 frame:single;
                 force:integer;
                 procedure processParameterList(p:TParameterList); override;
                 function getParameterList:TParameterList; override;
                 constructor Create(s:string; own:pointer); reintroduce;
                 procedure Render(timeDelta:integer); override;
                end;
     TCharged = class(TStone)
		 state:boolean;
                 charge:integer;
                 force:integer;
                 procedure processMessage(m:string;data:array of pointer); override;
                 procedure processParameterList(p:TParameterList); override;
                 function getParameterList:TParameterList; override;
                 constructor Create(s:string; own:pointer); reintroduce;
                 //procedure Render(timeDelta:integer); override;
                end;
     TWoodBridge = class(TStone)
                    vx,vz:integer;
                    frame:single;
                    procedure processMessage(m:string;data:array of pointer); override;
                    constructor Create(s:string; own:pointer); reintroduce;
                    procedure moveTo(tx,ty,tz:integer); override;
                    procedure Render(timeDelta:integer); override;
                   end;
     TGlass = class(TStone)
               procedure processMessage(m:string;data:array of pointer); override;
               constructor Create(s:string; own:pointer); reintroduce;
               //procedure Render(timeDelta:integer); override;
               destructor Destroy; override;
              end;
     TShogunStack = set of (SSs,SSm,SSl);
     TShogunStone = class(TStone)
                     stack:TShogunStack;
                     constructor Create(s:string; own:pointer); reintroduce;
                     //procedure Render(timeDelta:integer); override;
                     procedure setStack(st:TShogunStack);
                     procedure moveTo(tx,ty,tz:integer); override;
                     function moveQuery(tx,ty,tz:integer):boolean; override;
                    end;
     TSwapStone = class(TStone)
                   constructor Create(s:string; own:pointer); reintroduce;
                   //procedure Render(timeDelta:integer); override;
                   procedure moveTo(tx,ty,tz:integer); override;
                   function moveQuery(tx,ty,tz:integer):boolean; override;
                  end;
var  image_death:TO3mFile;
     images_actorcolor:array[TActorColorType] of TO3mFile;
     images_bolder:array[BN..BW] of TO3mFile;
     images_switch:array[false..true] of TO3mFile;
     image_door:TQuakeModel;
     image_block_break:TQuakeModel;
     images_charger:array[TCharge] of TO3mFile;
     images_charged:array[-1..1] of TO3mFile;
     image_wood:TO3mFile;
     image_glass:TO3mFile;
     image_swap:TO3mFile;
     images_shogun:array[1..7] of TO3mFile;
     ozone:TOzoneMainClass;


 procedure TSwapStone.moveTo;
 var s:TStone;
 begin
  if TLevel(owner).getCell(tx,ty,tz)=nil then exit;
  if not moveQuery(tx,ty,tz) then exit;
  s:=TLevel(owner).getCell(tx,ty,tz).FStone;
  s.x:=x;
  s.y:=y;
  s.z:=z;
  TLevel(owner).getCell(x,y,z).FStone:=s;
  s.processMessage('move',[]);
  x:=tx;
  y:=ty;
  z:=tz;
  TLevel(owner).getCell(tx,ty,tz).FStone:=self;
  processMessage('move',[]);
  TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('stone_move',cx,cy,cz);
 end;

 function TSwapStone.moveQuery;
 begin
  Result:=false;
  if TLevel(owner).getCell(tx,ty,tz).FStone<>nil then Result:=true;
 end;

{ procedure TSwapStone.Render;
 begin
  ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
 end;}

 constructor TSwapStone.Create;
 var t:string;
 begin
  inherited Create(s,'move',own);
  mu:=0;
  collisionCallback:=collFuncMove;
  AntiForce:=3;
  t:=GetToken(s,2,':');
  gfxType:=o3utils.ozone;
  gfx:=image_swap;
  shadow:=ozone.shadowLib['sh-stone'];
 end;


 function ShogunGfx(t:TShogunStack):Pointer;
 begin
  Result:=nil;
  if t=[SSs] then Result:=images_shogun[1];
  if t=[SSm] then Result:=images_shogun[2];
  if t=[SSl] then Result:=images_shogun[3];
  if t=[SSs,SSm] then Result:=images_shogun[4];
  if t=[SSs,SSl] then Result:=images_shogun[5];
  if t=[SSm,SSl] then Result:=images_shogun[6];
  if t=[SSs,SSm,SSl] then Result:=images_shogun[7];
 end;
 procedure TShogunStone.moveTo;
 var TransferStack:TShogunStack;
 begin
  if TLevel(owner).getCell(tx,ty,tz)=nil then exit;
  if not moveQuery(tx,ty,tz) then exit;
//  TLevel(owner).getCell(tx,ty,tz).FStone:=self;
//  TLevel(owner).getCell(x,y,z).FStone:=nil;
//  x:=tx;
//  y:=ty;
//  z:=tz;
//  processMessage('move',[]);
  if SSs in stack then begin TransferStack:=[SSs]; Exclude(stack,SSs); setStack(stack); end
  else if SSm in stack then begin TransferStack:=[SSm]; Exclude(stack,SSm); setStack(stack); end
  else if SSl in stack then begin TransferStack:=[SSl]; Exclude(stack,SSl); setStack(stack); end;
  if stack=[] then
    if TLevel(owner).getCell(tx,ty,tz).FStone=nil then begin
     setStack(TransferStack);
     TLevel(owner).getCell(tx,ty,tz).FStone:=self;
     TLevel(owner).getCell(x,y,z).FStone:=nil;
     x:=tx;
     y:=ty;
     z:=tz;
     TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('stone_move',cx,cy,cz);
     Exit;
    end
    else begin
     setStack(TransferStack+TShogunStone(TLevel(owner).getCell(tx,ty,tz).FStone).stack);
     TLevel(owner).getCell(tx,ty,tz).FStone.Free;
     TLevel(owner).getCell(tx,ty,tz).FStone:=self;
     TLevel(owner).getCell(x,y,z).FStone:=nil;
     x:=tx;
     y:=ty;
     z:=tz;
     TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('stone_move',cx,cy,cz);
     Exit;
    end;
  if TLevel(owner).getCell(tx,ty,tz).FStone=nil then begin
   TLevel(owner).getCell(tx,ty,tz).FStone:=TShogunStone.Create('st-shogun-s',owner);
   TLevel(owner).getCell(tx,ty,tz).FStone.x:=tx;
   TLevel(owner).getCell(tx,ty,tz).FStone.y:=ty;
   TLevel(owner).getCell(tx,ty,tz).FStone.z:=tz;
   TShogunStone(TLevel(owner).getCell(tx,ty,tz).FStone).setStack(TransferStack);
  end
  else
   TShogunStone(TLevel(owner).getCell(tx,ty,tz).FStone).setStack(TShogunStone(TLevel(owner).getCell(tx,ty,tz).FStone).stack+TransferStack);
  TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('stone_move',cx,cy,cz);
 end;

 function TShogunStone.moveQuery;
 begin
  Result:=false;
  if TLevel(owner).getCell(tx,ty,tz).FStone=nil then begin Result:=true; Exit; end;
  if TLevel(owner).getCell(tx,ty,tz).FStone.info['shogun']<>'yes' then begin Result:=False; exit; end;
  if (SSs in stack)and
     (not(SSs in TShogunStone(TLevel(owner).getCell(tx,ty,tz).FStone).stack)) then Result:=true;
  if (not(SSs in stack))and(SSm in stack)and
     (not((SSs in TShogunStone(TLevel(owner).getCell(tx,ty,tz).FStone).stack)or
     (SSm in TShogunStone(TLevel(owner).getCell(tx,ty,tz).FStone).stack))) then Result:=true;
//  Result:=false;
 end;

 procedure TShogunStone.SetStack;
 var s:string;
 begin
  stack:=st;
  if (SSl in stack) then shadow:=ozone.shadowLib['sh-stone']
  else if (SSm in stack) then shadow:=ozone.shadowLib['sh-shogunm']
  else shadow:=ozone.shadowLib['sh-shoguns'];
  gfx:=ShogunGfx(stack);
  if SSs in stack then s:=s+'s';
  if SSm in stack then s:=s+'m';
  if SSl in stack then s:=s+'l';
  info['stack']:=s;
 end;

{ procedure TShogunStone.Render;
 begin
  ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
 end;}
 
 constructor TShogunStone.Create;
 var t:string;
 begin
  inherited Create(s,'move',own);
  mu:=0;
  collisionCallback:=collFuncMove;
  AntiForce:=3;
  t:=GetToken(s,2,':');
  if Pos('s',t)<>0 then
   include(stack,SSs);
  if Pos('m',t)<>0 then
   include(stack,SSm);
  if Pos('l',t)<>0 then
   include(stack,SSl);
  if stack=[] then stack:=[SSs,SSm,SSl];
  gfxType:=o3utils.ozone;
  setStack(stack);//gfx:=ShogunGfx(stack);
  info['shogun']:='yes';
//  shadow:=ozone.shadowLib['sh-shoguns'];
 end;
 
 
 procedure TGlass.processMessage;
 begin
 end;

 constructor TGlass.Create;
 begin
  inherited Create(s,'block',own);
  mu:=0;
  gfx:=image_glass;
  gfxtype:=o3utils.ozone;
  info['laserpass']:='yes';
  collisionCallback:=collFuncBlock;
//  TLevel(owner).CallBackBuffer.Add(self);
  shadow:=ozone.shadowLib['sh-stone'];
 end;

 destructor TGlass.Destroy;
 begin
//  TLevel(owner).CallBackBuffer.FList.Remove(self);
  inherited;
 end;

{ procedure TGlass.Render;
 begin
  ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
 end;}

 procedure TWoodBridge.moveTo;
 var cell:TCell;
     ox,oz:integer;
 begin
  ox:=x;
  oz:=z;
  vx:=0;
  vz:=0;
  inherited;
  if y=ty then begin
   cell:=TLevel(owner).getCell(x,y-1,z);
   if cell=nil then exit;
   if cell.FStone=nil then exit;
   if cell.FStone.info['name']<>'st-flice' then exit;
   vx:=tx-ox;
   vz:=tz-oz;
  end;
 end;
 
 procedure TWoodBridge.processMessage;
 var cell1,cell2:TCell;
 begin
  if m='move' then begin
   if y<=0 then exit;
   cell1:=TLevel(owner).getCell(x,y-1,z);
   if cell1=nil then exit;
   if cell1.FStone<>nil then exit;
   cell2:=TLevel(owner).getCell(x,y,z);
   if cell2=nil then exit;
   if cell2.FStone=nil then exit;
   cell2.FStone:=nil;
   cell1.FStone:=Self;
  collisionCallback:=collFuncBlock;
   y:=y-1;
  end;
 end;

 constructor TWoodBridge.Create;
 begin
  inherited Create(s,'move',own);
  mu:=0;
  vx:=0;
  vz:=0;
  frame:=0;
  AntiForce:=2.5;
  gfx:=image_wood;
  gfxtype:=o3utils.ozone;
  collisionCallback:=collFuncMove;
  shadow:=ozone.shadowLib['sh-stone'];
 end;

 procedure TWoodBridge.Render;
 begin
  frame:=frame+timeDelta/200;
  if frame>1 then begin
   frame:=frame-1;
   moveTo(x+vx,y,z+vz);
  end;
  inherited Render(timeDelta);
//ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
 end;

 function CollFuncCharger(dir:integer;call:TStone;x,y,z:integer;actor:Pointer;level:Pointer;geom:pointer):boolean;
 begin
  result:=true;
  if TCharger(call).frame<=0 then TCharger(call).frame:=10;
  TActor(actor).ECharge:=TCharger(Call).charge*TCharger(Call).force;
 end;

 procedure TCharger.processParameterList(p:TParameterList);
 begin
  info['cmd']:=GetToken(info['cmd'],1,':')+':'+intToStr(p[0].uintValue);
 end;

 function TCharger.getParameterList:TParameterList;
 var t:TObjParameter;
 begin
  Result:=nil;
  if charge=0 then EXIT;
  Result:=TParameterList.Create;
  t:=TObjParameter.Create;
  t.desc:='Force';
  t.uintValue:=force;
  Result.add(t);
 end;


 constructor TCharger.Create;
 var t:string;
 begin
  inherited Create(s,'block',own);
  mu:=0;
  charge:=0;
  t:=GetToken(s,1,':');
  if Pos('st-chargeplus',t)<>0 then
   charge:=1;
  if Pos('st-chargeminus',t)<>0 then
   charge:=-1;
  frame:=0;
  force:=100;
  t:=GetToken(s,2,':');
  if t<>'' then
   force:=strToInt(t);
  gfx:=images_charger[charge];
  gfxtype:=o3utils.ozone;
  collisionCallback:=collFuncCharger;
  shadow:=ozone.shadowLib['sh-stone'];
 end;

 procedure TCharger.Render;
 var f:single;
 begin
  if frame>0 then begin
   f:=frame-5;
   TO3mFile(gfx).FObject.Kids^[1].Trans[1]:=(5-abs(f))/20;
   frame:=frame-timeDelta/50;
  end;
  //ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
  inherited Render(timeDelta);
  TO3mFile(gfx).FObject.Kids^[1].Trans[1]:=0;
 end;

 procedure TCharged.processParameterList(p:TParameterList);
 begin
  info['cmd']:=GetToken(info['cmd'],1,':')+':'+intToStr(p[0].uintValue);
 end;

 function TCharged.getParameterList:TParameterList;
 var t:TObjParameter;
 begin
  Result:=TParameterList.Create;
  t:=TObjParameter.Create;
  t.desc:='Force';
  t.uintValue:=force;
  Result.add(t);
 end;

 procedure TCharged.processMessage;
 begin
  if m='signal' then
   state:=not state;
  if state then begin
   echarge:=force*charge; 
   gfxtype:=o3utils.ozone;
   gfx:=images_charged[charge];
  end
  else begin
   echarge:=0; 
   gfxtype:=o3utils.ozone;
   gfx:=images_charged[0];
  end; 
 end;
  
 constructor TCharged.Create;
 var t:string;
 begin
  inherited Create(s,'block',own);
  mu:=0;
  charge:=1;
  state:=true;
  t:=GetToken(s,1,':');
  if Pos('st-chargedplus',t)<>0 then
   charge:=1;
  if Pos('st-chargedminus',t)<>0 then
   charge:=-1;
  force:=100;
  t:=GetToken(s,2,':');
  if t<>'' then
   force:=strToInt(t);
  echarge:=force*charge; 
  gfxtype:=o3utils.ozone;
  gfx:=images_charged[charge];
  t:=GetToken(s,3,':');
  if t='off' then
   processMessage('signal',[]);
  shadow:=ozone.shadowLib['sh-stone'];
 end;

{ procedure TCharged.Render;
 begin
  ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
 end;}

 function CollFuncDoor(dir:integer;call:TStone;x,y,z:integer;actor:Pointer;geom:Pointer;normal:pointer):boolean;
 begin
  if TDoor(call).dtype=h then begin
   if TDoor(call).anim<7 then result:=true
   else result:=false;
//   if(dir=3)or(dir=4)or(dir=1)or(dir=2) then result:=false;
   if(((TDoor(call).anim<2)and(TDoor(call).anim>5)and(TDoor(call).state))or(TDoor(call).anim=0)or(TDoor(call).anim=9))and(dir=0) then
    result:=false;
  end
  else begin
   if TDoor(call).anim<7 then result:=true
   else result:=false;
//   if(dir=3)or(dir=4)or(dir=5)or(dir=6) then result:=false;
   if(((TDoor(call).anim<2)and(TDoor(call).anim>5)and(TDoor(call).state))or(TDoor(call).anim=0)or(TDoor(call).anim=9))and(dir=0) then
    result:=false;
  end;
 end;

 procedure TDoor.Render;
 begin
  image_door.Frame:=anim;
  if state then
   image_door.animationStep(timeDelta/1000,10,false)
  else
   image_door.animationStep(-timeDelta/1000,10,false);
  anim:=image_door.Frame;
  if dType=h then image_door.Rotate[1]:=90;
  inherited Render(timeDelta);
//ozone.gfxSys.DrawModel(image_door,0,0,0,quake);
  image_door.Rotate[1]:=0;
 end;

 procedure TDoor.toggle;
 begin
  state:=not state;
  ozone.soundLib.playSound('door',cx,cy,cz);
 end;

 procedure TDoor.processMessage;
 begin
  if m='signal' then
   toggle;
 end;

 constructor TDoor.create;
 var n,a:string;
 begin
  state:=false;
  dType:=v;
  n:=GetToken(s,1,':');
  a:=GetToken(s,2,':');
  if a='open' then
   state:=true;
  if a='h' then
   dType:=h;
  a:=GetToken(s,3,':');
  if a='h' then
   dType:=h;
  inherited create(s,'',own);
  gfx:=image_door;
  gfxType:=quake;
  mu:=0;
  collisionCallback:=collFuncDoor;
 end;

 function CollFuncBlockBreak(dir:integer;call:TStone;x,y,z:integer;actor:Pointer;level:Pointer;geom:pointer):boolean;
 var item:TItem;
 begin
  Result:=true;
  if not TBlock_Break(call).isCracked then exit;
  if actor=nil then exit;
  if TActor(actor).inventary=nil then exit;
  if TActor(actor).inventary.count<=0 then exit;
  if TActor(actor).inventary.First=nil then exit;
  item:=TItem(TActor(actor).inventary.first);
  if (item<>nil)and(item.info['hammer']='yes')and(not TBlock_Break(call).isBreaking) then begin
   TBlock_Break(call).isBreaking:=true;
   ozone.soundLib.playSound('block_break',call.cx,call.cy,call.cz);
  end;
 end;

 procedure TBlock_Break.processParameterList(p:TParameterList);
 begin
  if p[0].boolValue then
   info['cmd']:=GetToken(info['cmd'],1,':')+':nocrack'
  else
   info['cmd']:=GetToken(info['cmd'],1,':');
 end;

 function TBlock_Break.getParameterList:TParameterList;
 var t:TObjParameter;
 begin
  Result:=TParameterList.Create;
  t:=TObjParameter.Create;
  t.desc:='Initially Cracked';
  t.boolValue:=isCracked;
  Result.add(t);
 end;

 procedure TBlock_Break.Render;
 begin
  if visible then begin
   if isCracked then begin
    image_Block_Break.Frame:=anim;
    if isBreaking then
     image_Block_Break.animationStep(timeDelta/1000,15,false);
    anim:=image_Block_Break.Frame;
    ozone.gfxSys.DrawModel(image_Block_Break,0,0.02,0,quake,gfxinfo);
    if anim>=7 then begin
     TLevel(owner).fcells[x,y,z].fstone:=nil;
     Free;
    end;
   end
   else
    ozone.gfxSys.DrawModel(ozone.Objects.Objects['st-block'],0,0.02,0,ozone.Objects.Raw['st-block'].actype,gfxInfo);
  end;
 end;

 procedure TBlock_Break.processMessage;
 begin
  if (m='laserhit')and(not isCracked) then begin
   isCracked:=true;
   ozone.soundLib.playSound('block_crack',cx,cy,cz);
  end;
 end;

 constructor TBlock_Break.create;
 var a:string;
 begin
  a:=GetToken(s,2,':');
  isCracked:=true;
  if a='nocrack' then
   isCracked:=false;
  anim:=0;
  isBreaking:=false;
  inherited create(s,'block',own);
  mu:=0;
  collisionCallback:=collFuncBlockBreak;
  shadow:=ozone.shadowLib['sh-stone'];
 end;

 function CollFuncSwitch(dir:integer;call:TStone;x,y,z:integer;actor:Pointer;level:Pointer;geom:pointer):boolean;
 begin
  result:=true;
  TSwitch(call).toggle;
 end;

{ procedure TSwitch.Render;
 begin
  ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
 end;}

 procedure TSwitch.toggle;
 begin
  state:=not state;
  gfxtype:=o3utils.ozone;
  gfx:=images_switch[state];
  if state then begin
   TLevel(owner).SendSignal(self,1);
   ozone.soundLib.playSound('switch_on',cx,cy,cz);
  end
  else begin
   TLevel(owner).SendSignal(self,0);
   ozone.soundLib.playSound('switch_off',cx,cy,cz);
  end;
 end;

 constructor TSwitch.create;
 var n,a:string;
 begin
  state:=false;
  n:=GetToken(s,1,':');
  a:=GetToken(s,2,':');
  if a='on' then
   state:=true;
  collisionCallback:=collFuncSwitch;
  inherited Create(s,'',own);
  mu:=0;
  gfxtype:=o3utils.ozone;
  gfx:=images_switch[state];
  shadow:=ozone.shadowLib['sh-stone'];
 end;

 procedure TBolder.processParameterList(p:TParameterList);
 begin
  info['cmd']:=GetToken(info['cmd'],1,':')+':'+floatToStr(p[0].floatValue);
 end;
 
 function TBolder.getParameterList:TParameterList;
 var t:TObjParameter;
 begin
  Result:=TParameterList.Create;
  t:=TObjParameter.Create;
  t.desc:='Speed';
  t.floatValue:=speed;
  Result.add(t);
 end;


 procedure TBolder.processMessage;
 begin
  if m='turnright'then begin
   direction:=TBolderDir((Ord(direction)+1)mod 4);
   gfxtype:=o3utils.ozone;
   gfx:=images_bolder[direction];
  end;
  if m='turnleft'then begin
   direction:=TBolderDir((Ord(direction)+3)mod 4);
   gfxtype:=o3utils.ozone;
   gfx:=images_bolder[direction];
  end;
  if (m='flip')or(m='signal') then begin
   direction:=TBolderDir((Ord(direction)+2)mod 4);
   gfxtype:=o3utils.ozone;
   gfx:=images_bolder[direction];
  end;
  if leftstr(m,8)='laserhit' then begin
   if not laserchange then begin
    direction:=TBolderDir((Ord(direction)+2)mod 4);
    gfxtype:=o3utils.ozone;
    gfx:=images_bolder[direction];
   end;
   laserchange:=true;
  end;
 end;

 function TBolder.NextX;
 begin
  Result:=X;
  case direction of
   BW:Result:=X-1;
   BE:Result:=X+1;
  end;
  if (Result<0)or(Result>=TLevel(owner).FX) then
   Result:=X;
 end;

 function TBolder.NextZ;
 begin
  Result:=Z;
  case direction of
   BS:Result:=Z+1;
   BN:Result:=Z-1;
  end;
  if (Result<0)or(Result>=TLevel(owner).FZ) then
   Result:=Z;
 end;

 procedure TBolder.CallBack;
 var ix,iz:integer;
     stone:TStone;
     cell:Tcell;
 begin
  inc(time,timeDelta);
  cell:=TLevel(owner).getCell(fx,fy,fz);
  if time>speed*1000 then begin
   dec(time,trunc(1000*speed));
   ix:=NextX;
   iz:=NextZ;
   if(cell<>nil)and(cell.FStone<>nil) then begin
    stone:=TLevel(owner).getCell(ix,y,iz).FStone;
    if stone=nil then begin
     TLevel(owner).FCells[fx,fy,fz].FStone:=nil;
     cx:=ix+0.5;
     cz:=iz+0.5;
     fx:=ix;
     fz:=iz;
     UpdateGeomPos;
     TLevel(owner).FCells[fx,fy,fz].FStone:=self;
     TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('stone_move',cx,cy,cz);
     laserchange:=false;
    end
    else begin
     ix:=(Ord(direction)+2)mod 4;
     stone.processMessage('boldercollision',[@ix]);
    end;
   end;
  end;
{  if (cell=nil)or(cell.FStone=nil) then begin
   cy:=cy-(timeDelta/500);
   ix:=ceil(cy-0.5);
   if fy<>ix then begin
    if cell<>nil then begin
     TLevel(owner).FCells[fx,fy,fz].FStone:=nil;
     cy:=ix+0.5;
     fy:=iz;
     UpdateGeomPos;
     TLevel(owner).FCells[fx,fy,fz].FStone:=self;
    end
    else begin
     if not outoflev then begin
      TLevel(owner).FCells[fx,fy,fz].FStone:=nil;
      TLevel(owner).CallBackBuffer.Add(self);
      outoflev:=true;
     end;
    end;
   end;
//   end;
//   if (cy<20) then
  end; }
 end;

 procedure TBolder.Render;
 begin
   inherited Render(timeDelta);
//  ozone.gfxSys.DrawModel(gfx,0,0,0,o3utils.ozone);
 end;

 destructor TBolder.Destroy;
 begin
  TLevel(owner).CallBackBuffer.Remove(self);
  inherited Destroy();
 end;

 constructor TBolder.create;
 var n,a:string;
 begin
  outoflev:=false;
  laserchange:=false;
  n:=GetToken(s,1,':');
  a:=GetToken(s,2,':');
  if a<>'' then
   speed:=strToFloat(a)
  else
   speed:=1;
  case RightStr(n,1)[1] of
   'n':direction:=BN;
   'e':direction:=BE;
   's':direction:=BS;
   'w':direction:=BW;
  end;
  time:=0;
  collisionCallback:=collFuncBlock;
  inherited Create(s,'',own);
  mu:=0;
  gfxtype:=o3utils.ozone;
  gfx:=images_bolder[direction];
  shadow:=ozone.shadowLib['sh-stone'];
  TLevel(owner).CallBackBuffer.Add(self);
 end;

 function CollFuncDeath(dir:integer;call:TStone;x,y,z:integer;actor:Pointer;level:Pointer;geom:pointer):boolean;
 begin
  result:=true;
  TActor(actor).processMessage('kill',[]);
 end;


 constructor TDeath.create;
 begin
  inherited Create(s,'',own);
  mu:=0;
  collisionCallback:=CollFuncDeath;
  gfx:=image_death;
  gfxtype:=o3utils.ozone;
  shadow:=ozone.shadowLib['sh-stone'];
 end;


{ procedure TDeath.Render;
 begin
  ozone.gfxSys.DrawModel(image_death,0,0,0,o3utils.ozone);
 end;}



 function CollFuncActorColor(dir:integer;call:TStone;x,y,z:integer;actor:Pointer;level:Pointer;geom:pointer):boolean;
 var i:integer;
     s:PdContactGeom;
 begin
  if geom=nil then begin
   Result:=false;
   exit;
  end;
  s:=geom;
  i:=0;
  TActor(actor).processMessage('marblecall',[@i]);
  case i of
   1: Result:=(s.normal[1]<>0)or(not (TActorColorStone(call).color=acColBlack));
   2: Result:=(s.normal[1]<>0)or(not (TActorColorStone(call).color=acColWhite));
   3: Result:=(s.normal[1]<>0)or(not (TActorColorStone(call).color=acColGreen));
   else Result:=true;
  end;
 end;


 constructor TActorColorStone.create;
 begin
  inherited Create(s,'nogeom',own);
  if LeftStr(s,10)='st-acwhite' then color:=acColWhite;
  if LeftStr(s,10)='st-acblack' then color:=acColBlack;
  if LeftStr(s,10)='st-acgreen' then color:=acColGreen;
  mu:=0;
  gfx:=images_actorcolor[color];
  gfxtype:=o3utils.ozone;
  CreateBodyAndGeom('model',geoms,body);
  collisionCallback:=CollFuncActorColor;
  x:=-1;
  y:=-1;
  z:=-1;
  shadow:=ozone.shadowLib['sh-acblack'];
 end;


{ procedure TActorColorStone.Render;
 begin
  ozone.gfxSys.DrawModel(gfx,0,0,0,gfxtype);
 end;}


  function MakeStone(s:string;o:Pointer):TStone;
  begin
   Result:=nil;
   if LeftStr(s,8)='st-death' then
    Result:=TDeath.create(s,o);
   if LeftStr(s,10)='st-acwhite' then
    Result:=TActorColorStone.create(s,o);
   if LeftStr(s,10)='st-acblack' then
    Result:=TActorColorStone.create(s,o);
   if LeftStr(s,10)='st-acgreen' then
    Result:=TActorColorStone.create(s,o);
   if LeftStr(s,14)='st-block-break' then
    Result:=TBlock_Break.create(s,o);
   if LeftStr(s,9)='st-switch' then
    Result:=TSwitch.create(s,o);
   if LeftStr(s,7)='st-wood' then
    Result:=TWoodBridge.create(s,o);
   if LeftStr(s,7)='st-swap' then
    Result:=TSwapStone.create(s,o);
   if LeftStr(s,8)='st-glass' then
    Result:=TGlass.create(s,o);
   if LeftStr(s,9)='st-bolder' then
    Result:=TBolder.create(s,o);
   if LeftStr(s,7)='st-door' then
    Result:=TDoor.create(s,o);
   if (LeftStr(s,9)='st-charge')and(s[10]<>'d') then
    Result:=TCharger.create(s,o);
   if LeftStr(s,10)='st-charged' then
    Result:=TCharged.create(s,o);
   if LeftStr(s,9)='st-shogun' then
    Result:=TShogunStone.create(s,o);
  end;

  procedure InitLib(path:string;owner:Pointer);
  begin
   ozone:=owner;
   image_death:=TO3mFile.Create(owner);
   image_death.LoadFromFile(path+'st-death.o3m');
   images_actorcolor[acColWhite]:=TO3mFile.Create(owner);
   images_actorcolor[acColWhite].LoadFromFile(path+'st-acwhite1.o3m');
   images_actorcolor[acColBlack]:=TO3mFile.Create(owner);
   images_actorcolor[acColBlack].LoadFromFile(path+'st-acblack1.o3m');
   images_actorcolor[acColGreen]:=TO3mFile.Create(owner);
   images_actorcolor[acColGreen].LoadFromFile(path+'st-acsmall1.o3m');
   image_wood:=TO3mFile.Create(owner);
   image_wood.LoadFromFile(path+'st-wood.o3m');
   image_glass:=TO3mFile.Create(owner);
   image_glass.LoadFromFile(path+'st-glass.o3m');
   image_swap:=TO3mFile.Create(owner);
   image_swap.LoadFromFile(path+'st-swap.o3m');
   images_bolder[BN]:=TO3mFile.Create(owner);
   images_bolder[BN].LoadFromFile(path+'st-bolder-n.o3m');
   images_bolder[BS]:=TO3mFile.Create(owner);
   images_bolder[BS].LoadFromFile(path+'st-bolder-s.o3m');
   images_bolder[BW]:=TO3mFile.Create(owner);
   images_bolder[BW].LoadFromFile(path+'st-bolder-w.o3m');
   images_bolder[BE]:=TO3mFile.Create(owner);
   images_bolder[BE].LoadFromFile(path+'st-bolder-e.o3m');
   images_switch[true]:=TO3mFile.Create(owner);
   images_switch[true].LoadFromFile(path+'st-switch-on.o3m');
   images_switch[false]:=TO3mFile.Create(owner);
   images_switch[false].LoadFromFile(path+'st-switch-off.o3m');
   image_door:=TQuakeModel.Create(owner);
   image_door.LoadModel(path+'st-door.md2','st-door.bmp');
   image_Block_Break:=TQuakeModel.Create(owner);
   image_Block_Break.LoadModel(path+'st-block-break.md2','st-block.bmp');
   image_Block_Break.autocalcVertexNormals;
   images_charger[-1]:=TO3mFile.Create(owner);
   images_charger[-1].LoadFromFile(path+'st-chargeminus.o3m');
   images_charger[0]:=TO3mFile.Create(owner);
   images_charger[0].LoadFromFile(path+'st-chargezero.o3m');
   images_charger[1]:=TO3mFile.Create(owner);
   images_charger[1].LoadFromFile(path+'st-chargeplus.o3m');
   images_charged[-1]:=TO3mFile.Create(owner);
   images_charged[-1].LoadFromFile(path+'st-chargedminus.o3m');
   images_charged[0]:=TO3mFile.Create(owner);
   images_charged[0].LoadFromFile(path+'st-chargedoff.o3m');
   images_charged[1]:=TO3mFile.Create(owner);
   images_charged[1].LoadFromFile(path+'st-chargedplus.o3m');

   images_shogun[1]:=TO3mFile.Create(owner);
   images_shogun[1].LoadFromFile(path+'st-shogun-s.o3m');
   images_shogun[2]:=TO3mFile.Create(owner);
   images_shogun[2].LoadFromFile(path+'st-shogun-m.o3m');
   images_shogun[3]:=TO3mFile.Create(owner);
   images_shogun[3].LoadFromFile(path+'st-shogun-l.o3m');
   images_shogun[4]:=TO3mFile.Create(owner);
   images_shogun[4].LoadFromFile(path+'st-shogun-sm.o3m');
   images_shogun[5]:=TO3mFile.Create(owner);
   images_shogun[5].LoadFromFile(path+'st-shogun-sl.o3m');
   images_shogun[6]:=TO3mFile.Create(owner);
   images_shogun[6].LoadFromFile(path+'st-shogun-ml.o3m');
   images_shogun[7]:=TO3mFile.Create(owner);
   images_shogun[7].LoadFromFile(path+'st-shogun-sml.o3m');
  end;

  procedure QuitLib;
  var x:integer;
  begin
   if image_death<>nil then image_death.Free;

   if images_actorcolor[acColWhite]<>nil then images_actorcolor[acColWhite].Free;
   if images_actorcolor[acColBlack]<>nil then images_actorcolor[acColBlack].Free;
   if images_actorcolor[acColGreen]<>nil then images_actorcolor[acColGreen].Free;

   if image_wood<>nil then image_wood.Free;
   if image_glass<>nil then image_glass.Free;
   if image_swap<>nil then image_swap.Free;
   if images_bolder[BN]<>nil then images_bolder[BN].Free;
   if images_bolder[BE]<>nil then images_bolder[BE].Free;
   if images_bolder[BS]<>nil then images_bolder[BS].Free;
   if images_bolder[BW]<>nil then images_bolder[BW].Free;
   if images_switch[false]<>nil then images_switch[false].Free;
   if images_switch[true]<>nil then images_switch[true].Free;
   if image_door<>nil then image_door.Free;
   if image_Block_Break<>nil then image_Block_Break.Free;
   if images_charger[-1]<>nil then images_charger[-1].Free;
   if images_charger[0]<>nil then images_charger[0].Free;
   if images_charger[1]<>nil then images_charger[1].Free;
   if images_charged[-1]<>nil then images_charged[-1].Free;
   if images_charged[0]<>nil then images_charged[0].Free;
   if images_charged[1]<>nil then images_charged[1].Free;
   for x:=1 to 7 do
    if images_shogun[x]<>nil then
     images_shogun[x].Free;
  end;


  exports InitLib,
          QuitLib,
          MakeStone;
begin
end.
