unit o3actors;

interface
 uses o3vectors,
      dglOpenGL,
      ac3d,
      o3stones,
      o3item,
      o3utils,
      odeimport,
      classes,
      sysutils,
      o3control,
      o3inventary,
      o3particles,
      o3m;

 type
        TActor = class;
        TActorInfo = record
         Mass:Single;
         steer:single;
        end;
        TSteerProc = function(actor:TGameObject):TVector3d;
        TActorPhysic = record
          steerPower:single;
          mass:single;
          noclip:boolean;
          GodY:single;
          selfFric:integer;
          floorSteerPower:single;
          godFor:integer;
          jumping:boolean;
        end;
        TActor = class(TGameObject)
         public
          shadow:integer;
          CanTakeUpItems:boolean;
          startx,starty,startz:single;
          flagx,flagy,flagz:single;
          body:PdxBody;
          geoms:TGeomList;
          collInfo:string;
          Inventary:TInventary;
          ControlProc:TO3Control;
          physics:TActorPhysic;
          outofgame:boolean;
          Falive:boolean;
          Look:integer;
          LookFar:boolean;
          LookFarness:single;
          bounceity:single;
          name:string;
          procedure setX(const val:single);
          procedure setY(const val:single);
          procedure setZ(const val:single);
          procedure SetAlive(const f:boolean); virtual;
          property alive:boolean read Falive write SetAlive;
          property x:Single read cx write setX;
          property y:Single read cy write setY;
          property z:Single read cz write setZ;
          procedure Render(timeDelta:integer); override;
          constructor Create(name:string;sx,sy,sz:Single;control:TO3Control;Own:Pointer;i:string;coll:string); reintroduce; virtual;
          destructor Destroy; override;
          procedure PickUpItem(Item:TItem;level:Pointer); virtual;
          procedure DropItem(level:Pointer;x,y,z:integer); virtual;
          procedure CreateBodyAndGeom(c:string;var g:TGeomList;var b:PdxBody); virtual;
          procedure ProcessOvers; virtual;
          procedure UseFirstItem; virtual;
          function getFirstItem:TItem; virtual;
          procedure RotateItems; virtual;
          procedure makeGodFor(dur:integer); virtual;
          function tryRebirth:boolean; virtual;
          procedure invalidatePhysics;
          procedure spawn(first:boolean=false); virtual;
          procedure spawnParticlesOwnColor(num:integer;randDir:single;color,speed,pos:TVector3d;Life,LifeRnd:integer;pmax:integer;callback:TParticleCallback;data:pointer); virtual;
          procedure processMessage(m:string;p:array of pointer); override;
          procedure playSound(reason:string;data:array of pointer); virtual;
          function getParameterList:TParameterList; override;
          procedure processParameterList(p:TParameterList); override;

        end;
        PActor = ^TActor;

implementation
uses o3world,
     o3objects,
     o3physics,
     o3game;

 function TActor.getParameterList:TParameterList;
 var t:TObjParameter;
 begin
  Result:=TParameterList.Create;
  t:=TObjParameter.Create;
  t.heightValue:=starty;
  t.desc:='Height';
  Result.Add(t);
 end;
 
 procedure TActor.processParameterList(p:TParameterList);
 begin
  starty:=p[0].heightValue;
  //y:=starty;
 end;

 procedure TActor.playSound;
 var c:^Single;
     vol:integer;
 begin
  if reason='accollision1' then begin
   c:=data[0];
   vol:=round(c^*25);
   if vol>100 then vol:=100;
   TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('stdcollision',cx,cy,cz,vol);
  end;
  if reason='kill' then begin
   if y>-4 then
    TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('actor_break',cx,cy,cz)
   else
    TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('actor_fallout',cx,cy,cz)
  end;
 end;

 procedure TActor.spawnParticlesOwnColor;
 begin

   if gfxType=ac then begin
    if (gfx<>nil)and(Length(TAC3dFile(gfx).FPalette)>0) then
    TLevel(owner).particleSystem.spawn(num,randDir,getVector(TAc3dFile(gfx).FPalette[0].RGB.r,TAc3dFile(gfx).FPalette[0].RGB.g,TAc3dFile(gfx).FPalette[0].RGB.b),speed,pos,life,lifernd,pmax,callback,data)
   else
    TLevel(owner).particleSystem.spawn(num,randDir,color,speed,pos,life,lifernd,pmax,callback,data);
  end
  else if gfxType=ozone then begin
   if (gfx<>nil)and(TO3mFile(gfx).FPalCount>0) then
    TLevel(owner).particleSystem.spawn(num,randDir,getVector(TO3mFile(gfx).FPalette^[0].RGB.r,TO3mFile(gfx).FPalette^[0].RGB.g,TO3mFile(gfx).FPalette^[0].RGB.b),speed,pos,life,lifernd,pmax,callback,data)
   else
    TLevel(owner).particleSystem.spawn(num,randDir,color,speed,pos,life,lifernd,pmax,callback,data);
   end;
 end;

 procedure TActor.invalidatePhysics;
 var i:integer;
 begin
  odeimport.dBodyDisable(body);
  if geoms.Count>0 then
   for i:=0 to geoms.Count-1 do
    odeimport.dGeomDisable(geoms[i]);
 end;

 function TActor.tryRebirth;
 begin
  Result:=false;
 end;

 procedure ActorCallBack(P:PParticle;t:integer);
 var acp,dist:TVector3d;
 begin
  if (p.data=nil)or(TGameObject(p.data)=nil) then EXIT;
  acp:=getVector(TGameObject(p.data).cx,TGameObject(p.data).cy,TGameObject(p.data).cz);
  dist:=sum(acp,mul(p.pos,-1));
  p.speed:=sum(p.speed,mul(norm(dist),t/200));
 end;

 procedure GravityCallBack(P:PParticle;t:integer);
 begin
  P.speed:=sum(p.speed,getVector(0,-0.981*(t/200),0));
 end;

 procedure TActor.setAlive;
 var b:boolean;
 begin
  if TLevel(owner).state=levWon then exit;
  //TOzoneMainClass(TLevel(owner).owner).O3Log.LogStatus('setting actor alive to '+BoolToStr(f,TRUE),'TActor.setAlive');
  if (not f) and (physics.godFor>0) and (TLevel(owner).state<>LevRestart) then Exit;
  if fAlive=f then exit;
  if OutOfGame then exit;
  if (not f) then begin
//   spawnParticlesOwnColor(2000,2,getVector(1,1,1),getVector(0.7,0.7,0.7),getVector(cx,cy,cz),1000,50,-1,GravityCallBack,nil);
   playSound('kill',[]);
   setCharge(0);
   b:=tryRebirth;
   if not b then begin
    OutOfGame:=true;
    invalidatePhysics;
//    TLevel(owner).particleSystem.spawn(3000,2,getVector(1,0,0),getVector(1,1,1),getVector(cx,cy,cz),2000,50,-1,nil,nil);
   end
   else begin
    physics.godFor:=1;
    physics.GodY:=-555;
    dBodySetLinearVel(body,0,0,0);
    dBodySetAngularVel(body,0,0,0);
    dBodySetForce(body,0,0,0);
    dBodySetTorque(body,0,0,0);
    spawn(true);
    //spawnParticlesOwnColor(1000,2,getVector(1,1,1),getVector(1,1,1),getVector(cx,cy,cz),1000,50,-1,ActorCallBack,self);
    FAlive:=true;
   end;
   if (TLevel(owner).theActorToFollow=Self)or(TLevel(owner).theActorToFollow2=Self) then
    TLevel(owner).notify1STdestroyed(b);
  end
  else
   FAlive:=true;
  TOzoneMainClass(TLevel(owner).owner).O3Log.LogStatus('setted alive without calling EXIT','TActor.setAlive');
 end;

 procedure TActor.makeGodFor;
 begin
  physics.GodY:=cy;
  physics.godFor:=dur;
 end;

 procedure TActor.UseFirstItem;
 begin
  if inventary.Count>0 then
   TItem(inventary[0]).OnUse(self,owner,trunc(x),trunc(y),trunc(z));
 end;

 function TActor.getFirstItem;
 begin
  Result:=nil;
  if inventary.Count>0 then
   Result:=TItem(inventary[0]);
 end;

 procedure TActor.RotateItems;
 begin
  inventary.rotate;
 end;

 procedure TActor.ProcessOvers;
 begin
 end;

 procedure TActor.setX;
 begin
  cx:=val;
  if body<>nil then
   odeimport.dBodySetPosition(body,cx,cy,cz);
 end;

 procedure TActor.setY;
 begin
  cy:=val;
  if body<>nil then
   odeimport.dBodySetPosition(body,cx,cy,cz);
 end;

 procedure TActor.setZ;
 begin
  cz:=val;
  if body<>nil then
   odeimport.dBodySetPosition(body,cx,cy,cz);
 end;

 procedure TActor.processMessage;
 begin
  if (m='kill')and(physics.godFor<=0)and(TLevel(owner).state<>levWon) then
   alive:=false;
 end;


 procedure TActor.PickUpItem;
 begin
  if not CanTakeUpItems then Exit;
 if (Inventary.Count>0)and(Inventary[0]<>nil)and(TItem(Inventary[0]).Info['grabitems']='yes') then begin
   TItem(Inventary[0]).processMessage('grab',[Item,Level,self]);
  end
  else if (Inventary.Count<13) then begin
   If item.x>=0 then begin
    TLevel(level).FCells[Item.x,Item.y,Item.z].Fitem:=nil;
    TOzoneMainClass(TLevel(owner).owner).soundLib.playSound('stdalert',Item.cx,Item.cy,Item.cz);
   end;
   Item.inventaryPos:=0;
   Item.wearingActor:=self;
   Item.x:=-1;
   Item.y:=-1;
   Item.z:=-1;
   inventary.insert(0,Item);
   Item.processMessage('takeup',[Item,Level,self]);
  end
 end;

 procedure TActor.DropItem;
 var px,py,pz:integer;
     item:TItem;
     cell:TCell;
 begin
  px:=x;
  py:=y;
  pz:=z;
  cell:=TLevel(level).getCell(px,py,pz);
  if (cell<>nil)and(cell.FItem=nil)and(inventary.count>0) and(inventary[0]<>nil) then begin
    item:=TItem(inventary[0]);
    inventary.delete(0);
    item.x:=px;
    item.y:=py;
    item.z:=pz;
    cell.FItem:=item;
    item.wearingActor:=nil;
    item.inventaryPos:=-1;
    Item.processMessage('drop',[Item,Level,self]);
  end;
 end;

 procedure TActor.Render;
 begin
  if (gfx<>nil) and visible then
        TOzoneMainClass(TLevel(owner).owner).gfxSys.DrawModel(gfx,x,y,z,gfxtype,gfxinfo);
 end;

 destructor TActor.Destroy;
 var x:integer;
 begin
  TOzoneMainClass(TLevel(owner).owner).O3Log.LogStatus('freeing actor '+name+','+ClassName,'TActor.Free');
  if Inventary.Count>0 then
   for x:=0 to Inventary.Count-1 do
    if Inventary[x]<>nil then
     if TItem(inventary[x])<>nil then
      TItem(inventary[x]).free;
//  Inventary.OwnsObjects:=true;
  Inventary.Clear;
  Inventary.Free;
//  Info.Free;
  if body<>nil then dBodyDestroy(body);
  if geoms<>nil then begin
   geoms.DeleteAllGeoms;
   geoms.Free;
  end;
  if controlProc<>nil then
   controlProc.Free;
  TOzoneMainClass(TLevel(owner).owner).O3Log.LogStatus('inherited!','TActor.Free');
  inherited Destroy;
  TOzoneMainClass(TLevel(owner).owner).O3Log.LogStatus('freed actor','TActor.Free');
 end;

 procedure TActor.CreateBodyAndGeom;
 begin
 end;

 procedure TActor.spawn;
 begin
  spawnParticlesOwnColor(1000,2,getVector(1,1,1),getVector(1,1,1),getVector(cx,cy,cz),1000,50,-1,ActorCallBack,self);
 end;

 constructor TActor.Create;
 begin
  inherited Create;
  objectType:=otActor;
  //if gfx=nil then gfxType:=ac;
  LookFar:=false;
  LookFarness:=0;
  Look:=0;
  Shadow:=0;
  canTakeUpItems:=true;
  physics.godFor:=0;
  physics.godY:=-1;
  physics.floorSteerPower:=1;
  physics.selfFric:=0;
  physics.noclip:=false;
  physics.mass:=1;
  //visible:=true;
  Owner:=own;
  x:=sx;
  y:=sy;
  z:=sz;
  flagx:=-1;
  flagy:=-1;
  flagz:=-1;
  startx:=sx;
  starty:=sy;
  startz:=sz;
  alive:=true;
  outOfGame:=false;
//  Info:=TInfoList.Create;
  info['type']:=name;
  info['cmd']:=i;
  body:=dBodyCreate(TLevel(own).Physics.theWorld);
  geoms:= TGeomList.Create;
//  InitAcPhysics(physics);
  inventary:=TOzoneMainClass(TLevel(owner).owner).invSys.NewInventary;
  collInfo:=coll;
  bounceity:=1;
  TOzoneMainClass(TLevel(owner).owner).O3Log.LogStatus('creating physics body','TActor.Create');
  CreateBodyAndGeom(collInfo,geoms,body);
  TOzoneMainClass(TLevel(owner).owner).O3Log.LogStatus('setting body defaults','TActor.Create');
  TOzoneMainClass(TLevel(owner).owner).O3Log.LogStatus('setting controls','TActor.Create');
  ControlProc:=control;
  dBodySetLinearVel(body,0,0,0);
  dBodySetAngularVel(body,0,0,0);
  dBodySetForce(body,0,0,0);
  dBodySetTorque(body,0,0,0);
  TOzoneMainClass(TLevel(owner).owner).O3Log.LogStatus('spawinig','TActor.Create');
  spawn(true);
 end;

end.
