unit o3control;

interface
uses SDL,
     dglOpenGL,
     o3vectors,
     Classes,
     SysUtils,
     o3utils
     {$IFDEF WIN32},Windows{$ENDIF},
     o3fpcloader;

type
     TO3Control = class
      function Steer(actor:pointer;timeDelta:integer):TVector3d; virtual;
     end;
     TControlList = class;
     TControlLib = class;
     TGetKeyProc = function:PUInt8;
     TGetMouseProc = function(var x,y:integer):UInt8;
     TRegisterProc = procedure(entry:pointer;o3_state:Pointer);
     TControlLib = class
     public
      FHandle:THandle;
      RegisterCtrl:TRegisterProc;
      constructor Create(name:string); virtual;
      destructor Destroy; override;
     end;
     TMakeCtrl = function:TO3Control;
     TControlEntry = record
      name:string;
      lib:TControlLib;
      MakeControl:TMakeCtrl;
     end;
     PControlEntry = ^TControlEntry;
     TControlList = class
      public
        FList:TList;
        owner:pointer;
        function find(n:string):PControlEntry;
        procedure add(n:string;lib:string);
        function getCtrl(n:string):TMakeCtrl;
        function GetSteer(c:string):TO3Control;
        property Control[s:string]:TMakeCtrl read getCtrl; default;
        constructor Create(filename:string;own:pointer);
        destructor Destroy; override;
     end;




//function o3GetSteer(c:string):TO3Control;
//procedure ControlsTick;

implementation
 uses o3opengl,odeimport,o3actors;



 constructor TControlLib.Create;
 begin
  inherited Create;
  FHandle:=LoadLibrary(PChar(name));
  @RegisterCtrl:=GetProcAddress(FHandle,'RegisterLib');
  if @RegisterCtrl=nil then
   raise Exception.CreateFmt('Can''t load library: %s; Doesn''t have any "Register" proc',[name]);
 end;

 destructor TControlLib.Destroy;
 begin
  if FHandle<>0 then begin
   FreeLibrary(FHandle);
  end;
  inherited Destroy;
 end;

 procedure TControlList.add;
 var x:PControlEntry;
 begin
  New(x);
  x.name:=n;
  x.MakeControl:=nil;
  x.lib:=TControlLib.Create(lib);
  x.lib.RegisterCtrl(x,owner);
  FList.Add(x);
 end;

 function TControlList.find;
 var x:integer;
 begin
  Result:=nil;
  if FList.Count>0 then begin
   for x:=0 to FList.Count-1 do
    if (FList.Items[x]<>nil) and (PControlEntry(FList.Items[x])^.name=n) then
     Result:=FList.Items[x];
  end;
 end;

 function TControlList.getCtrl;
 var entry:PControlEntry;
 begin
  Result:=nil;
  entry:=find(n);
  if entry<>nil then
   Result:=entry.MakeControl;
 end;

 constructor TControlList.Create;
  var F:TextFile;
    s,n,fn:string;
 begin
  inherited Create;
  owner:=own;
  DecimalSeparator:='.';
  FList:=TList.Create;
  AssignFile(F,filename);
  Reset(F);
  while(not Eof(F)) do begin
   ReadLn(F,s);
   n:=GetToken(s,1,' ');
   fn:=extractFilePath(filename)+PathDelim+GetToken(s,2,' ')+LibExt;
   add(n,fn);
  end;
  CloseFile(F);
 end;

 destructor TControlList.Destroy;
 var x:integer;
 begin
  if FList.Count>0 then
   for x:=0 to FList.Count-1 do
    if FList[x]<>nil then begin
     PControlEntry(FList[x]).lib.Free;
     Dispose(FList[x]);
    end;
  FList.Free;
  inherited Destroy;
 end;

 function TO3Control.Steer;
 begin
 end;

 function TControlList.GetSteer(c:string):TO3Control;
 begin
  Result:=nil;
  if c='1' then c:='mouse';
  if c='2' then c:='keyboard';
  if @control[c]<>nil then
   Result:=Self.Control[c]();
 end;


end.
