unit o3io_sdlogl;

interface
uses o3interfaces,
     SDL,dglOpenGL,
     o3sound,
     o3opengl,
     o3particles_opengl,
     o3input_sdl,
     o3inventary_sdlogl;
type
 TO3IOSystem_SDLOGL = class(TO3IOSystem)
  surface:PSDL_Surface;
  function getTicks:cardinal; override;
  constructor Create(own:pointer;SCREEN_HEIGHT,SCREEN_WIDTH,SCREEN_BPP:cardinal;fullscreen:boolean); override;
  destructor Destroy; override;
 end;
implementation
 uses o3game;
 function TO3IOSystem_SDLOGL.getTicks;
 begin
  Result:=SDL_GetTicks;
 end;
 
 constructor TO3IOSystem_SDLOGL.Create;
 var videoFlags:UInt32;
 begin
  inherited;
  InitOpenGL;
//  if ParamStr(1)='800' then begin
//    SCREEN_WIDTH := 800;
//    SCREEN_HEIGHT := 600;
//  end;
//  if ParamStr(1)='640' then begin
//    SCREEN_WIDTH := 640;
//    SCREEN_HEIGHT := 480;
//  end;
//  if ParamStr(2)='32' then
//   SCREEN_BPP:=32;
//  if ParamStr(2)='16' then
//   SCREEN_BPP:=16;

  if ( SDL_Init( SDL_INIT_VIDEO or SDL_INIT_TIMER or SDL_INIT_AUDIO ) < 0 ) then
  begin
//    Log.LogError( Format( 'SDL_INIT error : %s', [SDL_GetError] ), 'Main');
    Free;
  end;
  videoFlags := SDL_OPENGL or SDL_DOUBLEBUF or SDL_HWPALETTE or SDL_HWSURFACE or SDL_HWACCEL;
  if fullscreen then
   videoFlags:=videoFlags or SDL_FULLSCREEN;
  SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
  SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );
  SDL_GL_SetAttribute( SDL_GL_STENCIL_SIZE, 8);

  if ( SCREEN_HEIGHT = 0 ) then
    SCREEN_HEIGHT := 1;
  SDL_ShowCursor(0);
  if paramStr(1)<>'nograb' then SDL_WM_GrabInput(SDL_GRAB_ON);
  surface := SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, videoflags );
  glViewport( 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT );
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity;
  gluPerspective( TOzoneMainClass(own).O3Ini.ReadInteger('gfxdebug','viewport1',55), SCREEN_WIDTH / SCREEN_HEIGHT, 0.1, 100.0 );
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity;
  SDL_WM_SetCaption('OZONE',nil);
  SoundSys:=TO3SoundSystem_SDL.Create(own);
  TOzoneMainClass(owner).soundSys:=soundSys;
  GfxSys:=TO3GfxSystem_OGLSDL.Create(own);
  TOzoneMainClass(owner).gfxSys:=gfxSys;
  InputSystem:=TO3InputSystem_SDL.create(own);
  TO3InputSystem_SDL(InputSystem).screensf:=surface;
  TOzoneMainClass(owner).InputSys:=InputSystem;
  ParticleGfxSys:=TO3ParticleSystemGfx_OGL.Create(own);
  TOzoneMainClass(owner).particleSysGfx:=particleGfxSys;
  InvSys:=TO3InvSystem_SDLOGL.create(own);
  TOzoneMainClass(owner).invSys:=invSys;
//  InitGL;
//  InitParticleSystem;
//  TO
 end;

destructor TO3IOSystem_SDLOGL.Destroy;
begin
 SoundSys.Free;
 ParticleGfxSys.Free;
 InvSys.Free;
 InputSystem.Free;
 GfxSys.Free;
 glDeleteLists(0,10000);
 SDL_WM_GrabInput(SDL_GRAB_OFF);
 SDL_ShowCursor(1);
 SDL_QUIT;
 //UnLoadOpenGL;
end;
end.
