unit o3levelinterface;

interface
uses o3control,o3stones,o3item,o3actors,sysutils{$IFDEF WIN32},windows{$ENDIF},o3fpcloader;
 type
   TLoadLevelProc=procedure(params:string;level:pointer);
   TSaveLevelProc=procedure(params:string;level:pointer);
   TUnLoadLevelProc = procedure();
   TLevelLib = class
    public
     FHandle:THandle;
     LoadLevel:TLoadLevelProc;
     SaveLevel:TSaveLevelProc;
     UnLoadLevel:TUnLoadLevelProc;
     constructor Create(name:string); virtual;
     destructor Destroy; override;
    end;

implementation

 constructor TLevelLib.Create;
 begin
  inherited Create;
  FHandle:=LoadLibrary(PChar(name));
  @LoadLevel:=GetProcAddress(FHandle,'LoadLevel');
  @SaveLevel:=GetProcAddress(FHandle,'SaveLevel');
  @UnLoadLevel:=GetProcAddress(FHandle,'UnLoadLevel');
 end;

 destructor TLevelLib.Destroy;
 begin
  if FHandle<>0 then begin
   if @UnLoadLevel<>nil then
    UnLoadLevel;
   FreeLibrary(FHandle);
  end;
  inherited Destroy;
 end;

end.
