unit o3objects;
interface
uses Classes,ac3d,dglOpenGL,o3utils,SysUtils,o3vectors,o3basicstones,o3stones,o3item,o3actors,o3m;
type
        TACObject = record
         ac:Pointer;
         actype:TModelType;
         name:string;
         stoneInfo:TStoneInfo;
         actorInfo:TActorInfo;
         bounceity:single;
         collInfo:string;
         shadow:string;
        end;
        PACObject = ^TACObject;
        TObjectList = class
         private
          FList:TList;
          function getObject(s:string):Pointer;
          function getRaw(s:string):TACObject;
         public
          owner:pointer;
          function addObject(name,filename:string):PACObject;
          property Objects[s:string]:Pointer read getObject; default;
          property Raw[s:string]:TACObject read getRaw;
          constructor create(filename:string;own:pointer);
          destructor destroy; override;
        end;


 function CreateStone(t:string;owner:Pointer):TStone;
 function CreateItem(t:string;owner:Pointer):TItem;
 function CreateActor(name:string;sx,sy,sz:single;own:Pointer;info:string):TActor;
implementation
 uses o3specialstones,
      o3world,
      o3basicobj,
      o3control,
      o3specialitems,
      o3opengl,
      o3actorinterface,
      o3game;

 function CreateStone;
 var s:string;
     objects:TObjectList;
     specialStones:TSpecialStoneList;
 begin
  s:=GetToken(t,1,':');
  Result:=nil;
  specialStones:=TOzoneMainClass(TLevel(owner).owner).SpecialStones;
  objects:=TOzoneMainClass(TLevel(owner).owner).objects;
  if SpecialStones[s]<>nil then
     Result := SpecialStones[s].MakeStone(t,owner)
  else if s<>'nil' then begin
   Result:=TStone.Create(s,Objects.Raw[s].collInfo,owner);
   with Result do begin
    if Objects<>nil then begin
     gfx:=Objects[s];
     gfxType:=Objects.Raw[s].actype;
     DecimalSeparator:='.';
     info['bounceity']:=FloatToStr(objects.Raw[s].bounceity);
    end;
   end;
   Result.fric:=Objects.Raw[s].stoneInfo.fric;
   Result.steer:=Objects.Raw[s].stoneInfo.steer;
   Result.mu:=Objects.Raw[s].stoneInfo.mu;
   Result.antiForce:=Objects.Raw[s].stoneInfo.antiForce;
   Result.shadow:=TOzoneMainClass(TLevel(owner).owner).ShadowLib[objects.Raw[s].shadow];
  end;
  //if Result<>nil then
//   Result.t:=stone;
 end;

 function CreateItem;
 var s:string;
     objects:TObjectList;
     specialItems:TSpecialItemList;
 begin
  objects:=TOzoneMainClass(TLevel(owner).owner).objects;
  specialItems:=TOzoneMainClass(TLevel(owner).owner).SpecialItems;
  s:=GetToken(t,1,':');
  Result:=nil;
  if SpecialItems[s]<>nil then
     Result := SpecialItems[s].MakeItem(t,owner)
  else
   if s<>'nil' then begin
    Result:=TItem.Create(s,owner);
    with Result do begin
     if Objects<>nil then begin
      gfx:=Objects[s];
      gfxType:=Objects.Raw[s].actype;
      DecimalSeparator:='.';
      info['bounceity']:=FloatToStr(objects.Raw[s].bounceity);
     end;
    end;
   end;
//  if Result<>nil then
//   Result.t:=item;
 end;

 function CreateActor;
 var s:string;
     objects:TObjectList;
     specialActors:TSpecialActorList;
 begin
  objects:=TOzoneMainClass(TLevel(own).owner).objects;
  specialActors:=TOzoneMainClass(TLevel(own).owner).SpecialActors;
  s:=GetToken(name,1,':');
  if SpecialActors[s]<>nil then
   Result := SpecialActors[s].MakeActor(name,sx,sy,sz,nil,own,info)
  else begin
   Result:=TActor.Create(name,sx,sy,sz,nil,own,info,Objects.Raw[name].collInfo);
   with result do begin
    gfx:=Objects[name];
    gfxType:=Objects.Raw[name].actype;
    Physics.steerPower:=Objects.Raw[name].actorInfo.steer;
    Physics.mass:=Objects.Raw[name].actorInfo.mass;
    bounceity:=Objects.Raw[name].bounceity;
   end;
  end;
 end;


 function TObjectList.getObject;
 var x:integer;
 begin
  Result:=nil;
  if FList.Count>0 then begin
   for x:=0 to FList.Count-1 do begin
    if (FList.Items[x]<>nil)and(PACObject(FList.Items[x])^.name=s) then Result:=PACObject(FList.Items[x])^.ac;
   end;
  end;
 end;

 function TObjectList.getRaw;
 var x:integer;
 begin
  if FList.Count>0 then begin
   Result:=PACObject(FList.Items[0])^;
   for x:=0 to FList.Count-1 do begin
    if (FList.Items[x]<>nil)and(PACObject(FList.Items[x])^.name=s) then Result:=PACObject(FList.Items[x])^;
   end;
  end;
 end;

 function TObjectList.addObject;
 var e:PACObject;
 begin
  New(e);
  e^.name:=name;
//  writeln(ExtractFileExt(FileName));
  if ExtractFileExt(FileName)='.o3m' then begin
   e^.ac:=TO3mFile.Create(owner);
   TO3mFile(e^.ac).LoadFromFile(FileName);
   e^.actype:=ozone;
  end
  else begin
   e^.ac:=TAC3DFile.Create(owner);
   TAC3DFile(e^.ac).LoadFromFile(FileName);
   e^.actype:=ac;
  end;
  FList.Add(e);
  Result:=e;
 end;

 constructor TObjectList.create;
 var F:TextFile;
     s,t,n,fn:string;
     l:PACObject;
 begin
  inherited Create;
  owner:=own;
  DecimalSeparator:='.';
  FList:=TList.Create;
  AssignFile(F,filename);
  Reset(F);
  while(not Eof(F)) do begin
   ReadLn(F,s);
   if (s='')or(s[1]='#') then CONTINUE;
   n:=GetToken(s,1,' ');
   fn:=GetToken(s,2,' ');
   TOzoneMainClass(own).gfxSys.writeProgress('loading '+n);
   fn:=TOzoneMainClass(own).path+ModelSubDir+fn;
   l:=addObject(n,fn);

   t:=GetToken(s,3,' ');
   l^.collInfo:=t;

   t:=GetToken(s,4,' ');
   if t='DEAD' then begin end
   else if t<>'' then
    l^.stoneInfo.fric:=StrToFloat(t);

   t:=GetToken(s,5,' ');
   if t<>'' then begin
    l^.stoneInfo.steer:=StrToFloat(t);
    l^.actorInfo.steer:=StrToFloat(t);
   end;

   t:=GetToken(s,6,' ');
   if t<>'' then begin
    l^.stoneInfo.antiForce:=StrToFloat(t);
    l^.actorInfo.Mass:=StrToFloat(t);
   end;

   t:=GetToken(s,7,' ');
   if t<>'' then begin
    l^.bounceity:=StrToFloat(t);
   end;

   l^.shadow:='';

   t:=GetToken(s,8,' ');
   if t<>'' then begin
    l^.shadow:=t;
   end;

   l^.stoneInfo.mu:=100;

   t:=GetToken(s,9,' ');
   if t<>'' then begin
    l^.stoneInfo.mu:=StrToFloat(t);
   end;

  end;
  CloseFile(F);
 end;

 destructor TObjectList.destroy;
 var x:integer;
 begin
  for x:=0 to FList.Count-1 do begin
   if FList.Items[x]<>nil then begin
    if PACObject(FList.Items[x])^.actype=ac then
     TAC3dFile(PACObject(FList.Items[x])^.ac).Free;
    if PACObject(FList.Items[x])^.actype=ozone then
     TO3mFile(PACObject(FList.Items[x])^.ac).Free;
    Dispose(FList.Items[x]);
   end;
  end;
  FList.Free;
  inherited;
 end;
end.
