unit o3opengl_font;

interface
uses dglOpenGL,
     SDL,
     o3utils,
     SDL_Image,
     StrUtils,
     o3interfaces;

type
TO3GfxSystem_SDLOGL_FontSubSys = class
 FontTex: Cardinal;
 base: cardinal;
 GfxSys: TO3GfxSystem;
 procedure DrawText( tx, ty : single; Text : string; fontset : cardinal; s:single;r,g,b:single;reset:boolean=true );
 constructor Create(GfxSystem: TO3GfxSystem);
 destructor Destroy; override;
end;


implementation
 uses o3game;

destructor TO3GfxSystem_SDLOGL_FontSubSys.Destroy;
begin
 glDeleteLists(base,256);
 GfxSys.FreeTexture(FontTex);
end;

constructor TO3GfxSystem_SDLOGL_FontSubSys.Create;
var
  loop : Cardinal; // Loop variable               */
  x : single; // Holds Our X Character Coord */
  y : single; // Holds Our Y Character Coord */
begin
  GfxSys:=GfxSystem;
  GfxSys.LoadTexture(FontTex,'font-big.png',BitmapSubDir);
  glEnable(GL_TEXTURE_2D);
  // Creating 256 Display List */
  base := glGenLists( 256 );
  /// Select Our Font Texture */
  glBindTexture( GL_TEXTURE_2D, FontTex );
  // Loop Through All 256 Lists */
  for loop := 0 to 255 do
  begin
    // X Position Of Current Character
    x := ( loop mod 16 ) / 16;
    // Y Position Of Current Character */
    y := ( loop div 16 ) / 16;

    // Start Building A List
    glNewList( base + loop , GL_COMPILE );
    // Use A Quad For Each Character
    glBegin( GL_QUADS );
    // Texture Coord (Bottom Left)
 {   glTexCoord2f( cx - 0.0625, cy );
    // Vertex Coord (Bottom Left) */
    glVertex2i( 0, 16 );

    // Texture Coord (Bottom Right)
    glTexCoord2f( cx, cy );
    // Vertex Coord (Bottom Right)
    glVertex2i( 16, 16 );

    // Texture Coord (Top Right)
    glTexCoord2f( cx, cy - 0.0625 );
    // Vertex Coord (Top Right)
    glVertex2i( 16, 0 );

    // Texture Coord (Top Left)
    glTexCoord2f( cx - 0.0625, cy - 0.0625 );
    // Vertex Coord (Top Left)
    glVertex2i( 0, 0 );}
	glTexCoord2f(x, y);
        glVertex2i(0, 16);
	glTexCoord2f(x + 0.0625, y);
        glVertex2i(16, 16);
        glTexCoord2f(x + 0.0625, y + 0.0625);
        glVertex2i(16, 0);
        glTexCoord2f(x, y + 0.0625);
        glVertex2i(0, 0);
    glEnd;

    // Move To The Left Of The Character
    glTranslated( 16, 0, 0 );
    glEndList;
  end;
  glDisable(GL_TEXTURE_2D);
end;

procedure TO3GfxSystem_SDLOGL_FontSubSys.DrawText;
begin
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity;
  glOrtho(-1.33,1.33,-1/TOzoneMainClass(gfxSys.owner).vsplit,1/TOzoneMainClass(gfxSys.owner).vsplit,5,-5);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix;
  if reset then glLoadIdentity;
  glColor3f( r,g,b );
  glDisable(GL_CULL_FACE);
  if ( fontset > 1 ) then
    fontset := 1;
  glEnable( GL_TEXTURE_2D );
  glBindTexture( GL_TEXTURE_2D, FontTex );
  glDisable( GL_DEPTH_TEST );
  glDisable(GL_LIGHTING);
  if reset then glTranslated( tx,ty/TOzoneMainClass(gfxSys.owner).vsplit, 0 )
  else glTranslated(tx,ty/TOzoneMainClass(gfxSys.owner).vsplit,0);
  glScalef( 0.005*s, 0.005*s, 1 );
//  glBlendFunc(GL_SRC_COLOR,GL_ONE);
  glListBase( (base - 32 + ( 128 * fontset )) );
  glCallLists( Length( Text ), GL_BYTE, PChar( Text ) );
  if reset then begin
   glDisable( GL_TEXTURE_2D );
   glEnable( GL_DEPTH_TEST );
   glEnable(GL_LIGHTING);
  end;
  glPopMatrix;
  glMatrixMode(GL_PROJECTION);
  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
//  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
end;


end.
