unit o3particles_opengl;

interface
uses o3interfaces,
     o3particles,
     dglOpenGL,
     Math,
     o3vectors;
type
     TO3ParticleSystemGfx_OGL = class(TO3ParticleSystemGfx)
     public
       particleTex:Cardinal;
       function NewParticleSystem:pointer; override;
       procedure RenderParticleSystem(psys:pointer;deltaTime:integer); override;
       constructor Create(own:pointer); override;
       destructor Destroy; override;
     end;
implementation
uses o3game,o3utils;
 procedure TO3ParticleSystemGfx_OGL.RenderParticleSystem;
 var x:integer;
    p:PParticle;
    a:array[0..15] of Single;
    Up,Right:TVector3d;
 begin
  with TParticleSystem(psys) do begin
   if particles.Count<=0 then EXIT;
   glDisable(GL_LIGHTING);
   glDisable(GL_CULL_FACE);
   glEnable( GL_TEXTURE_2D );
   glBindTexture( GL_TEXTURE_2D, particleTex );
   glDepthMask(false);
   glGetFloatv(GL_MODELVIEW_MATRIX,@a);
   Right:=mul(getVector(a[0],a[4],a[8]),0.1);
   Up:=mul(getVector(a[1],a[5],a[9]),0.1);
   for x:=0 to particles.Count-1 do begin
     p:=particles[x];
    dec(p.life,deltaTime);
    if @p.Callback<>nil then
     p.Callback(p,deltaTime);
    if p.life<=0 then
     CONTINUE;
     p.pos:=sum(p.pos,mul(p.speed,deltaTime/1000));
    glColor4d(p.color[0],p.color[1],p.color[2],min(p.life/p.maxlife,1));
    glBegin(GL_QUADS);
     glTexCoord2d(1,1);
     glVertex3d( p.pos[0] + Right[0] + Up[0], p.pos[1] + Right[1] + Up[1], p.pos[2] + Right[2] + Up[2] );
     glTexCoord2d(0,1);
     glVertex3d( p.pos[0] - Right[0] + Up[0], p.pos[1] - Right[1] + Up[1], p.pos[2] - Right[2] + Up[2] );
     glTexCoord2d(0,0);
     glVertex3d( p.pos[0] - Right[0] - Up[0], p.pos[1] - Right[1] - Up[1], p.pos[2] - Right[2] - Up[2] );
     glTexCoord2d(1,0);
     glVertex3d( p.pos[0] + Right[0] - Up[0], p.pos[1] + Right[1] - Up[1], p.pos[2] + Right[2] - Up[2] );
    glEnd;
   end;
   x:=0;
   while x<particles.Count do begin
   p:=particles[x];
    if p.life<=0 then
     particles.Delete(x)
    else inc(x);
   end;
   glEnable(GL_LIGHTING);
   glEnable(GL_CULL_FACE);
   glDepthMask(TRUE);
  end;
 end;

 constructor TO3ParticleSystemGfx_OGL.Create;
 begin
  inherited;
  TOzoneMainClass(owner).gfxSys.LoadTexture(particleTex,'particle.png',BitmapSubDir);
 end;

 destructor TO3ParticleSystemGfx_OGL.Destroy;
 begin
  TOzoneMainClass(owner).gfxSys.FreeTexture(particleTex);
  inherited;
 end;

 function TO3ParticleSystemGfx_OGL.NewParticleSystem;
 begin
  Result:=TParticleSystem.Create;
  TParticleSystem(Result).owner:=self;
 end;
end.
