unit o3shadowlib;

interface

uses
  Classes, SysUtils, o3m;
type
 TShadowGfx = record
  gfx:TO3mFile;
  name:string;
 end;
 PShadowGfx = ^TShadowGfx;
 TShadowLib = class
 public
  FList:TList;
  shpath:string;
  owner:pointer;
  function getShadow(name:string):integer;
  function getShadowGfx(id:integer):PShadowGfx;
  property ShadowID[ name:string ]:integer read getShadow; default;
  property ShadowGFX[ id:integer ]:PShadowGfx read getShadowGfx;
  constructor Create(own:pointer;path:string);
  destructor Destroy; override;
 end;
implementation
uses o3game;
 function TShadowLib.getShadow;
 var x,i:integer;
     p:PShadowGfx;
 begin
  i:=0;
  Result:=0;
  if (name='')or(name='sh-none') then exit;
  if FList.Count>0 then begin
   for x:=0 to FList.Count-1 do begin
    if (FList[x]<>nil) and (PShadowGfx(FList[x]).name=name) then begin
     i:=x+1;
     BREAK;
    end;
   end;
  end;
  if i=0 then begin
   New(p);
   p.name:=name;
   p.gfx:=TO3mFile.Create(owner);
   if p.gfx.LoadFromFile(shpath+name+'.o3m') then
    i:=FList.Add(p)+1
   else begin
    i:=0;
    p.gfx.Free;
    Dispose(p);
   end;
  end;
  Result:=i;
 end;

 function TShadowLib.getShadowGfx;
 begin
  Result:=nil;
  if (id>0) and (id<=FList.Count)  then
   Result:=FList[id-1];
 end;

 constructor TShadowLib.Create;
 begin
  inherited Create;
  shpath:=path;
  owner:=own;
  FList:=TList.Create;
 end;
 
 destructor TShadowLib.Destroy;
 var x:integer;
 begin
  TOzoneMainClass(owner).O3Log.LogStatus('freeing shadow library','TShadowLib.Destroy');
  if FList.Count>0 then
   for x:=0 to FList.Count-1 do
    if FList[x]<>nil then begin
     TOzoneMainClass(owner).O3Log.LogStatus('freeing shadow "'+PShadowGfx(Flist[x]).name+'"','TShadowLib.Destroy');
     PShadowGfx(Flist[x]).gfx.Free;
     Dispose(PShadowGfx(Flist[x]));
    end;
  FList.Clear;
  FList.Free;
  TOzoneMainClass(owner).O3Log.LogStatus('freed shadow library','TShadowLib.Destroy');
  inherited Destroy;
 end;
end.

