unit o3sndlib;

interface
uses o3interfaces,
     o3utils,
     SysUtils,
     Classes,
     Math;
type
 TLibEntry = record
  chunk:pointer;
  name:string;
 end;
 PLibEntry = ^TLibEntry;
 TSoundLib = class
  SndList:TList;
  SndIO:TO3SoundSystem;
  owner:pointer;
  fxVolume:integer;
  constructor Create(indexFile:string;SoundSystem:TO3SoundSystem;own:pointer);
  destructor Destroy; override;
  procedure playSound(name:string;x,y,z:single;volume:integer=100;xv:single = 0;yv:single = 0;zv:single = 0);
 end;
implementation
 uses o3game;

 procedure TSoundLib.playSound;
 var i:integer;
 begin
  if SndList.Count>0 then
   for i:=0 to SndList.Count-1 do
    if SndList[i]<>nil then
     if PLibEntry(SndList[i]).name=name then begin
       SndIO.PlaySound(PLibEntry(SndList[i]).chunk,x,y,z,xv,yv,zv,min(round(fxVolume*volume/100),100));
     end;
 end;

 constructor TSoundLib.Create;
 var index:TextFile;
     cEntry:PLibEntry;
     cChunk:Pointer;
     cFile:string;
     cName:string;
     cLine:string;
 begin
  inherited Create;
  fxVolume:=100;
  SndIO:=SoundSystem;
  SndList:=TList.Create;
  owner:=own;
  Assign(index,indexFile);
  Reset(index);
  while not Eof(index) do begin
   ReadLn(index,cLine);
   cName:=GetToken(cLine,1,' ');
   cFile:=ExtractFilePath(indexFile)+PathDelim+GetToken(cLine,2,' ');
   if not FileExists(cFile) then begin
    TOzoneMainClass(owner).O3Log.LogError('Sound file "'+cFile+'" not found!','TSoundLib.Create');
    CONTINUE;
   end;
   cChunk:=SndIO.LoadSound(cFile);
   if cChunk=nil then begin
    TOzoneMainClass(owner).O3Log.LogError('Can''t load sound file "'+cFile+'"!','TSoundLib.Create');
    CONTINUE;
   end;
   New(cEntry);
   cEntry.chunk:=cChunk;
   cEntry.name:=cName;
   SndList.Add(cEntry);
  end;
  Close(index);
 end;

 destructor TSoundLib.Destroy;
 var x:integer;
     cEntry:PLibEntry;
 begin
  if SndList.Count>0 then
   for x:=0 to SndList.Count-1 do
    if SndList[x]<>nil then begin
     cEntry:=SndList[x];
     SndIO.FreeSound(cEntry.chunk);
     Dispose(cEntry);
    end;
  SndList.Clear;
  SndList.Free;
  inherited Destroy;
 end;
end.
