unit o3specialinterface;

interface
 uses {$IFDEF WIN32}Windows,{$ENDIF}o3utils,o3opengl,SysUtils,o3world,o3fpcloader;
 type    TInitProc = procedure(path:string;ozone_state:Pointer);
         TQuitProc = procedure();
         TSpecialLib = class
         public
          FHandle:THandle;
          Init:TInitProc;
          Quit:TQuitProc;
          constructor Create(name:string;owner:pointer); virtual;
          destructor Destroy; override;
        end;

implementation

 constructor TSpecialLib.Create;
 begin
  inherited Create;
  FHandle:=LoadLibrary(PChar(name));
  @Init:=GetProcAddress(FHandle,'InitLib');
  @Quit:=GetProcAddress(FHandle,'QuitLib');
  if @Init<>nil then
    Init(ExtractFilePath(name),owner)
   else Self.Free;
 end;

 destructor TSpecialLib.Destroy;
 begin
  if FHandle<>0 then begin
//   if @Quit<>nil then
//    Quit;
   FreeLibrary(FHandle);
  end;
  inherited Destroy;
 end;


end.
