unit o3specialitems;

interface
uses o3item,
     o3specialinterface,
     classes,
     o3utils,
     sysutils,
     o3inventary
     {$IFDEF WIN32},Windows{$ENDIF},
     o3fpcloader;
     type
        TMakeItemFunc = function(s:string;owner:Pointer):TItem;
  //      TSetTexProcs = procedure(createproc:TCreateItemGfx;freeproc:TFreeItemGfx);
        TSpecialItemLibrary = class(TSpecialLib)
         public
          MakeItem:TMakeItemFunc;
//          SetTexProcs:TSetTexProcs;
          constructor Create(name:string;owner:pointer); override;
        end;
        TSpecialItemAlias = record
         Lib:TSpecialItemLibrary;
         name:string;
        end;
        TSpecialItemName = record
         Lib:string;
         name:string;
        end;
        PSpecialItemAlias = ^TSpecialItemAlias;
        PSpecialItemName = ^TSpecialItemName;
        TSpecialItemList = class
         private
          FList:TList;
          LList:TList;
          owner:pointer;
          function getObject(s:string):TSpecialItemLibrary;
          function getLib(s:string):TSpecialItemLibrary;
         public
          procedure addObject(name,libname:string);
          property Alias[s:string]:TSpecialItemLibrary read getObject; default;
          property Lib[s:string]:TSpecialItemLibrary read getLib;
          constructor create(filename:string;own:pointer);
          destructor destroy; override;
        end;

implementation
 uses o3game;
 function TSpecialItemList.getObject;
 var x:integer;
 begin
  Result:=nil;
  if FList.Count>0 then begin
   for x:=0 to FList.Count-1 do begin
    if (FList.Items[x]<>nil)and(PSpecialItemName(FList.Items[x])^.name=s) then
     Result:=Lib[PSpecialItemName(FList.Items[x])^.Lib];
   end;
  end;
 end;

 function TSpecialItemList.getLib;
 var x:integer;
 begin
  Result:=nil;
  if LList.Count>0 then begin
   for x:=0 to LList.Count-1 do begin
    if (LList.Items[x]<>nil)and(PSpecialItemAlias(LList.Items[x])^.name=s) then Result:=PSpecialItemAlias(LList.Items[x])^.Lib;
   end;
  end
 end;

 procedure TSpecialItemList.addObject;
 var f:PSpecialItemAlias;
     e:PSpecialItemName;
 begin
  New(e);
  e^.name:=name;
  e^.Lib:=libname;
  if Lib[libname]=nil then begin
   New(f);
   f^.name:=libname;
   f^.Lib:=TSpecialItemLibrary.Create(TOzoneMainClass(owner).path+ModelSubDir+libname+LibExt,owner);
   LList.Add(f);
  end;
  FList.Add(e);
 end;

{ procedure TSpecialItemList.addObject;
 var e:PSpecialItemAlias;
 begin
  New(e);
  e^.name:=name;
  e^.Lib:=TSpecialItemLibrary.Create(OxydPath+ModelSubDir+libname+LibExt);
  FList.Add(e);
 end;
 }
 constructor TSpecialItemList.create;
 var F:TextFile;
     s,n,fn:string;
 begin
  owner:=own;
  inherited Create;
  DecimalSeparator:='.';
  FList:=TList.Create;
  LList:=TList.Create;
  AssignFile(F,filename);
  Reset(F);
  while(not Eof(F)) do begin
   ReadLn(F,s);
   n:=GetToken(s,1,' ');
   fn:=GetToken(s,2,' ');
   TOzoneMainClass(own).gfxSys.writeProgress('loading '+fn);
   addObject(n,fn);
  end;
  CloseFile(F);
 end;

 destructor TSpecialItemList.destroy;
 var x:integer;
 begin
  if FList.Count>0 then
   for x:=0 to FList.Count-1 do begin
    if FList.Items[x]<>nil then begin
     Dispose(FList.Items[x]);
    end;
   end;
  FList.Free;
  if LList.Count>0 then
   for x:=0 to LList.Count-1 do begin
    if LList.Items[x]<>nil then begin
     if PSpecialItemAlias(LList.Items[x])^.Lib<>nil then
      PSpecialItemAlias(LList.Items[x])^.Lib.Free;
     Dispose(LList.Items[x]);
    end;
   end;
  LList.Free;
  inherited;
 end;

 constructor TSpecialItemLibrary.Create;
 begin
   inherited;
  if Self<>nil then begin
//   @SetTexProcs:=GetProcAddress(FHandle,'SetTexProcs');
//   if @SetTexProcs<>nil then
//    SetTexProcs(CreateItemGfx,FreeItemGfx);
   @MakeItem:=GetProcAddress(FHandle,'MakeItem');
  end;
 end;



end.
