unit o3vectors;

interface
uses dglOpenGL,
odeimport;

type TRect3d = record
      x,y,z:integer;
      w,h,t:integer;
     end;

function SwapXZ(T:TVector3d):TVector3d;
function absVec(T:TVector3d):TVector3d;
function Rect3d(x,y,z,w,h,t:integer):TRect3d;
function Norm(t:TVector3d):TVector3d;
function sum(t1,t2:TVector3d):TVector3d;
function sub(t1,t2:TVector3d):TVector3d;
function mul(t1:TVector3d;multi:Double):TVector3d;
function cross(v1,v2:TVector3d):TVector3d;
function mulvec(t1,t2:TVector3d):TVector3d;
procedure roundIt(var t:tVector3d);
function getVector(x,y,z:single):TVector3d;
procedure oneVec(var t:TVector3d);
function len(t:TVector3d;x,y,z:single):single;
function lenSqr(t:TVector3d):single;
function toVector3d(t:PdVector3):TVector3d;

implementation
function cross(v1,v2:TVector3d):TVector3d;
begin
 Result[0]:= v1[1] * v2[2] - v2[1] * v1[2];
 Result[1]:= v2[0] * v1[2] - v1[0] * v2[2];
 Result[2]:= v1[0] * v2[1] - v2[0] * v1[1];
end;

function toVector3d(t:PdVector3):TVector3d;
begin
 if t=nil then
  Result:=getVector(0,0,0)
 else
  Result:=getVector(t[0],t[1],t[2]);
end;


function Rect3d;
begin
 Result.x:=x;
 Result.y:=y;
 Result.z:=z;
 Result.h:=h;
 Result.w:=w;
 Result.t:=t;
end;

function Norm(t:TVector3d):TVector3d;
var len:single;
begin
 len:=sqrt(t[0]*t[0]+t[1]*t[1]+t[2]*t[2]);
 if len=0 then len:=1;
 Result[0]:=t[0]/len;
 Result[1]:=t[1]/len;
 Result[2]:=t[2]/len;
end;

function absVec(T:TVector3d):TVector3d;
begin
 Result[0]:=abs(T[0]);
 Result[1]:=abs(T[1]);
 Result[2]:=abs(T[2]);
end;

function SwapXZ(T:TVector3d):TVector3d;
begin
 Result[0]:=t[2];
 Result[1]:=t[1];
 Result[2]:=t[0];
end;

function sum(t1,t2:TVector3d):TVector3d;
begin
 Result[0]:=t1[0]+t2[0];
 Result[1]:=t1[1]+t2[1];
 Result[2]:=t1[2]+t2[2];
end;

function sub(t1,t2:TVector3d):TVector3d;
begin
 Result[0]:=t1[0]-t2[0];
 Result[1]:=t1[1]-t2[1];
 Result[2]:=t1[2]-t2[2];
end;

function mul(t1:TVector3d;multi:Double):TVector3d;
begin
 Result[0]:=t1[0]*multi;
 Result[1]:=t1[1]*multi;
 Result[2]:=t1[2]*multi;
end;

function mulvec(t1,t2:TVector3d):TVector3d;
begin
 Result[0]:=t1[0]*t2[0];
 Result[1]:=t1[1]*t2[1];
 Result[2]:=t1[2]*t2[2];
end;

procedure roundIt(var t:tVector3d);
begin
 if abs(t[0])<1E-5 then t[0]:=0;
 if abs(t[1])<1E-5 then t[1]:=0;
 if abs(t[2])<1E-5 then t[2]:=0;
end;

function getVector(x,y,z:single):TVector3d;
begin
 Result[0]:=x;
 Result[1]:=y;
 Result[2]:=z;
end;

procedure oneVec(var t:TVector3d);
begin
 if t[0]<0.5 then t[0]:=0
             else t[0]:=1;
 if t[1]<0.5 then t[1]:=0
             else t[1]:=1;
 if t[2]<0.5 then t[2]:=0
             else t[2]:=1;
end;

function len(t:TVector3d;x,y,z:single):single;
begin
 Result:=sqrt((t[0]*x)*(t[0]*x)+(t[1]*y)*(t[1]*y)+(t[2]*z)*(t[2]*z));
end;

function lenSqr(t:TVector3d):single;
begin
 Result:=t[0]*t[0]+t[1]*t[1]+t[2]*t[2];
end;

end.
